/* A Bison parser, made by GNU Bison 3.0.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


#line 568 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    DEFINE = 277,
    ON = 278,
    OFF = 279,
    YES = 280,
    NO = 281,
    S = 282,
    MS = 283,
    US = 284,
    LOG = 285,
    SYSLOG = 286,
    ALL = 287,
    DEBUG = 288,
    TRACE = 289,
    INFO = 290,
    REMOTE = 291,
    WARNING = 292,
    ERROR = 293,
    AUTH = 294,
    FATAL = 295,
    BUG = 296,
    STDERR = 297,
    SOFT = 298,
    TIMEFORMAT = 299,
    ISO = 300,
    OLD = 301,
    SHORT = 302,
    LONG = 303,
    BASE = 304,
    NAME = 305,
    CONFIRM = 306,
    UNDO = 307,
    CHECK = 308,
    TIMEOUT = 309,
    CONFIGURE = 310,
    DOWN = 311,
    KERNEL = 312,
    PERSIST = 313,
    SCAN = 314,
    TIME = 315,
    LEARN = 316,
    DEVICE = 317,
    ROUTES = 318,
    KRT_SOURCE = 319,
    KRT_METRIC = 320,
    TABLE = 321,
    KRT_PREFSRC = 322,
    KRT_REALM = 323,
    ROUTER = 324,
    ID = 325,
    PROTOCOL = 326,
    TEMPLATE = 327,
    PREFERENCE = 328,
    DISABLED = 329,
    DIRECT = 330,
    INTERFACE = 331,
    IMPORT = 332,
    EXPORT = 333,
    FILTER = 334,
    NONE = 335,
    STATES = 336,
    FILTERS = 337,
    RECEIVE = 338,
    LIMIT = 339,
    ACTION = 340,
    WARN = 341,
    BLOCK = 342,
    RESTART = 343,
    DISABLE = 344,
    KEEP = 345,
    FILTERED = 346,
    PASSWORD = 347,
    FROM = 348,
    PASSIVE = 349,
    TO = 350,
    EVENTS = 351,
    PACKETS = 352,
    PROTOCOLS = 353,
    INTERFACES = 354,
    PRIMARY = 355,
    STATS = 356,
    COUNT = 357,
    FOR = 358,
    COMMANDS = 359,
    PREEXPORT = 360,
    GENERATE = 361,
    ROA = 362,
    MAX = 363,
    FLUSH = 364,
    AS = 365,
    LISTEN = 366,
    BGP = 367,
    V6ONLY = 368,
    DUAL = 369,
    ADDRESS = 370,
    PORT = 371,
    PASSWORDS = 372,
    DESCRIPTION = 373,
    SORTED = 374,
    RELOAD = 375,
    IN = 376,
    OUT = 377,
    MRTDUMP = 378,
    MESSAGES = 379,
    RESTRICT = 380,
    MEMORY = 381,
    IGP_METRIC = 382,
    CLASS = 383,
    DSCP = 384,
    SHOW = 385,
    STATUS = 386,
    SUMMARY = 387,
    ROUTE = 388,
    SYMBOLS = 389,
    ADD = 390,
    DELETE = 391,
    DUMP = 392,
    RESOURCES = 393,
    SOCKETS = 394,
    NEIGHBORS = 395,
    ATTRIBUTES = 396,
    EVAL = 397,
    ECHO = 398,
    ENABLE = 399,
    FUNCTION = 400,
    PRINT = 401,
    PRINTN = 402,
    UNSET = 403,
    RETURN = 404,
    ACCEPT = 405,
    REJECT = 406,
    QUITBIRD = 407,
    INT = 408,
    BOOL = 409,
    IP = 410,
    PREFIX = 411,
    PAIR = 412,
    QUAD = 413,
    EC = 414,
    SET = 415,
    STRING = 416,
    BGPMASK = 417,
    BGPPATH = 418,
    CLIST = 419,
    ECLIST = 420,
    IF = 421,
    THEN = 422,
    ELSE = 423,
    CASE = 424,
    TRUE = 425,
    FALSE = 426,
    RT = 427,
    RO = 428,
    UNKNOWN = 429,
    GENERIC = 430,
    GW = 431,
    NET = 432,
    MASK = 433,
    PROTO = 434,
    SOURCE = 435,
    SCOPE = 436,
    CAST = 437,
    DEST = 438,
    IFNAME = 439,
    IFINDEX = 440,
    LEN = 441,
    DEFINED = 442,
    CONTAINS = 443,
    RESET = 444,
    PREPEND = 445,
    FIRST = 446,
    LAST = 447,
    MATCH = 448,
    ROA_CHECK = 449,
    EMPTY = 450,
    WHERE = 451,
    BFD = 452,
    MIN = 453,
    IDLE = 454,
    RX = 455,
    TX = 456,
    INTERVAL = 457,
    MULTIPLIER = 458,
    MULTIHOP = 459,
    NEIGHBOR = 460,
    DEV = 461,
    LOCAL = 462,
    SESSIONS = 463,
    HOLD = 464,
    CONNECT = 465,
    RETRY = 466,
    KEEPALIVE = 467,
    STARTUP = 468,
    VIA = 469,
    NEXT = 470,
    HOP = 471,
    SELF = 472,
    DEFAULT = 473,
    PATH = 474,
    METRIC = 475,
    START = 476,
    DELAY = 477,
    FORGET = 478,
    WAIT = 479,
    AFTER = 480,
    BGP_PATH = 481,
    BGP_LOCAL_PREF = 482,
    BGP_MED = 483,
    BGP_ORIGIN = 484,
    BGP_NEXT_HOP = 485,
    BGP_ATOMIC_AGGR = 486,
    BGP_AGGREGATOR = 487,
    BGP_COMMUNITY = 488,
    BGP_EXT_COMMUNITY = 489,
    RR = 490,
    RS = 491,
    CLIENT = 492,
    CLUSTER = 493,
    AS4 = 494,
    ADVERTISE = 495,
    IPV4 = 496,
    CAPABILITIES = 497,
    PREFER = 498,
    OLDER = 499,
    MISSING = 500,
    LLADDR = 501,
    DROP = 502,
    IGNORE = 503,
    REFRESH = 504,
    INTERPRET = 505,
    COMMUNITIES = 506,
    BGP_ORIGINATOR_ID = 507,
    BGP_CLUSTER_LIST = 508,
    IGP = 509,
    GATEWAY = 510,
    RECURSIVE = 511,
    MED = 512,
    TTL = 513,
    SECURITY = 514,
    DETERMINISTIC = 515,
    SECONDARY = 516,
    ALLOW = 517,
    OSPF = 518,
    AREA = 519,
    OSPF_METRIC1 = 520,
    OSPF_METRIC2 = 521,
    OSPF_TAG = 522,
    OSPF_ROUTER_ID = 523,
    RFC1583COMPAT = 524,
    STUB = 525,
    TICK = 526,
    COST = 527,
    COST2 = 528,
    RETRANSMIT = 529,
    HELLO = 530,
    TRANSMIT = 531,
    PRIORITY = 532,
    DEAD = 533,
    TYPE = 534,
    BROADCAST = 535,
    BCAST = 536,
    NONBROADCAST = 537,
    NBMA = 538,
    POINTOPOINT = 539,
    PTP = 540,
    POINTOMULTIPOINT = 541,
    PTMP = 542,
    SIMPLE = 543,
    AUTHENTICATION = 544,
    STRICT = 545,
    CRYPTOGRAPHIC = 546,
    ELIGIBLE = 547,
    POLL = 548,
    NETWORKS = 549,
    HIDDEN = 550,
    VIRTUAL = 551,
    LINK = 552,
    ONLY = 553,
    BUFFER = 554,
    LARGE = 555,
    NORMAL = 556,
    STUBNET = 557,
    TAG = 558,
    EXTERNAL = 559,
    LSADB = 560,
    ECMP = 561,
    WEIGHT = 562,
    NSSA = 563,
    TRANSLATOR = 564,
    STABILITY = 565,
    GLOBAL = 566,
    LSID = 567,
    INSTANCE = 568,
    REAL = 569,
    NETMASK = 570,
    TOPOLOGY = 571,
    STATE = 572,
    PIPE = 573,
    PEER = 574,
    MODE = 575,
    OPAQUE = 576,
    TRANSPARENT = 577,
    RIP = 578,
    INFINITY = 579,
    PERIOD = 580,
    GARBAGE = 581,
    MULTICAST = 582,
    QUIET = 583,
    NOLISTEN = 584,
    VERSION1 = 585,
    PLAINTEXT = 586,
    MD5 = 587,
    HONOR = 588,
    NEVER = 589,
    ALWAYS = 590,
    RIP_METRIC = 591,
    RIP_TAG = 592,
    STATIC = 593,
    PROHIBIT = 594,
    MULTIPATH = 595,
    BLACKHOLE = 596,
    UNREACHABLE = 597
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 497 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 978 "cf-parse.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 993 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2684

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  364
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  251
/* YYNRULES -- Number of rules.  */
#define YYNRULES  816
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1536

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   597

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     355,   356,    28,    26,   360,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   357,   354,
      23,    22,    24,   361,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   362,     2,   363,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   358,     2,   359,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   683,   683,   684,   687,   689,   697,   706,   707,   708,
     715,   716,   717,   725,   726,   727,   728,   729,   730,   736,
     737,   744,   745,   749,   756,   757,   761,   765,   772,   780,
     781,   787,   796,   797,   801,   806,   807,   811,   812,   816,
     817,   821,   822,   823,   824,   825,   826,   827,   828,   829,
     835,   836,   845,   846,   847,   848,   851,   852,   853,   854,
     855,   856,   860,   867,   870,   877,   880,   883,   886,   890,
     891,   895,   896,   897,   905,   910,   911,   915,   922,   928,
     933,   937,   951,   965,   966,   970,   971,   972,   983,   985,
     987,   991,   992,   993,   994,  1001,  1002,  1006,  1014,  1018,
    1020,  1026,  1027,  1034,  1035,  1039,  1045,  1049,  1059,  1061,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1080,  1081,  1082,  1083,  1087,  1088,  1089,  1090,
    1091,  1095,  1101,  1105,  1113,  1114,  1122,  1130,  1131,  1132,
    1136,  1137,  1141,  1146,  1147,  1150,  1158,  1162,  1163,  1169,
    1176,  1177,  1178,  1182,  1190,  1196,  1197,  1198,  1202,  1203,
    1207,  1208,  1209,  1210,  1211,  1212,  1218,  1219,  1220,  1224,
    1225,  1229,  1230,  1236,  1237,  1240,  1242,  1246,  1247,  1251,
    1269,  1270,  1271,  1272,  1273,  1274,  1282,  1285,  1288,  1291,
    1295,  1296,  1299,  1302,  1306,  1310,  1315,  1321,  1328,  1333,
    1338,  1343,  1347,  1351,  1355,  1365,  1373,  1377,  1384,  1385,
    1390,  1394,  1401,  1408,  1412,  1420,  1421,  1422,  1427,  1431,
    1434,  1435,  1436,  1437,  1438,  1439,  1440,  1445,  1450,  1458,
    1465,  1472,  1480,  1482,  1484,  1486,  1488,  1490,  1492,  1495,
    1499,  1505,  1506,  1507,  1511,  1512,  1518,  1520,  1522,  1524,
    1526,  1528,  1532,  1536,  1539,  1543,  1544,  1545,  1549,  1550,
    1551,  1559,  1559,  1569,  1573,  1574,  1575,  1576,  1577,  1578,
    1579,  1580,  1581,  1582,  1583,  1584,  1585,  1606,  1617,  1618,
    1625,  1626,  1633,  1642,  1646,  1650,  1674,  1675,  1679,  1692,
    1692,  1708,  1709,  1712,  1713,  1717,  1720,  1729,  1742,  1743,
    1744,  1745,  1749,  1750,  1751,  1752,  1753,  1757,  1760,  1761,
    1762,  1766,  1769,  1778,  1781,  1782,  1783,  1784,  1788,  1789,
    1790,  1794,  1795,  1796,  1797,  1801,  1802,  1803,  1804,  1808,
    1809,  1813,  1814,  1818,  1825,  1826,  1827,  1828,  1835,  1836,
    1839,  1840,  1847,  1859,  1860,  1864,  1865,  1869,  1870,  1871,
    1872,  1873,  1877,  1878,  1879,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1897,  1898,  1908,  1912,
    1935,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,
    1971,  1972,  1973,  1974,  1975,  1976,  1977,  1979,  1980,  1981,
    1983,  1985,  1987,  1989,  1990,  1991,  1992,  1993,  2003,  2004,
    2005,  2006,  2007,  2008,  2009,  2011,  2012,  2017,  2040,  2041,
    2042,  2043,  2044,  2045,  2049,  2052,  2053,  2054,  2062,  2069,
    2078,  2079,  2083,  2089,  2099,  2108,  2114,  2119,  2126,  2131,
    2137,  2138,  2139,  2147,  2148,  2149,  2150,  2151,  2157,  2169,
    2170,  2171,  2172,  2175,  2177,  2181,  2185,  2196,  2197,  2198,
    2199,  2200,  2201,  2204,  2206,  2209,  2211,  2214,  2217,  2222,
    2223,  2224,  2228,  2229,  2233,  2234,  2237,  2255,  2261,  2283,
    2284,  2285,  2286,  2287,  2297,  2298,  2299,  2300,  2301,  2302,
    2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,  2311,  2312,
    2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,  2321,  2322,
    2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,  2336,
    2337,  2338,  2339,  2340,  2341,  2342,  2343,  2354,  2364,  2365,
    2369,  2370,  2371,  2372,  2373,  2374,  2375,  2378,  2393,  2396,
    2398,  2402,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,
    2411,  2411,  2412,  2412,  2413,  2414,  2415,  2419,  2420,  2424,
    2432,  2434,  2438,  2439,  2440,  2444,  2445,  2448,  2450,  2453,
    2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,  2463,
    2466,  2488,  2489,  2490,  2491,  2492,  2493,  2494,  2495,  2496,
    2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,  2505,  2506,
    2507,  2508,  2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,
    2517,  2518,  2519,  2520,  2521,  2522,  2523,  2526,  2528,  2531,
    2533,  2542,  2544,  2545,  2548,  2550,  2554,  2555,  2558,  2568,
    2591,  2593,  2596,  2598,  2601,  2603,  2607,  2611,  2612,  2617,
    2620,  2623,  2628,  2631,  2636,  2639,  2643,  2647,  2650,  2651,
    2652,  2653,  2654,  2655,  2656,  2657,  2663,  2670,  2671,  2672,
    2677,  2678,  2684,  2691,  2692,  2693,  2694,  2695,  2696,  2697,
    2698,  2699,  2700,  2701,  2702,  2703,  2707,  2708,  2709,  2714,
    2715,  2716,  2717,  2718,  2721,  2722,  2723,  2724,  2725,  2726,
    2727,  2730,  2732,  2735,  2737,  2741,  2753,  2760,  2767,  2768,
    2769,  2770,  2771,  2774,  2783,  2791,  2798,  2799,  2803,  2808,
    2814,  2817,  2822,  2823,  2824,  2825,  2826,  2829,  2836,  2836,
    2836,  2836,  2836,  2836,  2836,  2836,  2836,  2836,  2836,  2836,
    2836,  2836,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,
    2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,
    2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,
    2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,
    2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2838,  2838,
    2838,  2838,  2838,  2838,  2838,  2838,  2838,  2839,  2839,  2839,
    2839,  2840,  2840,  2840,  2841,  2841,  2841,  2841,  2841,  2842,
    2842,  2843,  2844,  2845,  2846,  2847,  2848,  2849,  2850,  2851,
    2852,  2853,  2853,  2853,  2853,  2853,  2853
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "LOG", "SYSLOG", "ALL",
  "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL",
  "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT", "LONG",
  "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "KRT_SOURCE", "KRT_METRIC", "TABLE", "KRT_PREFSRC", "KRT_REALM",
  "ROUTER", "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED",
  "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES",
  "FILTERS", "RECEIVE", "LIMIT", "ACTION", "WARN", "BLOCK", "RESTART",
  "DISABLE", "KEEP", "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO",
  "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS",
  "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE", "ROA", "MAX",
  "FLUSH", "AS", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS", "PORT",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "IF",
  "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN",
  "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE", "CAST",
  "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK", "EMPTY", "WHERE",
  "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL", "MULTIPLIER", "MULTIHOP",
  "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD", "CONNECT", "RETRY",
  "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH",
  "METRIC", "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "OSPF", "AREA",
  "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "TYPE", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "SIMPLE", "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE",
  "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "ONLY", "BUFFER",
  "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP",
  "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID",
  "INSTANCE", "REAL", "NETMASK", "TOPOLOGY", "STATE", "PIPE", "PEER",
  "MODE", "OPAQUE", "TRANSPARENT", "RIP", "INFINITY", "PERIOD", "GARBAGE",
  "MULTICAST", "QUIET", "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5",
  "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG", "STATIC",
  "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "';'", "'('", "')'",
  "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept", "config",
  "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "tab_sorted", "newtab", "roa_table_start", "roa_table_opts", "roa_table",
  "proto_start", "proto_name", "proto_item", "imexport", "limit_action",
  "limit_spec", "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_init", "iface_patt", "tos",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_cfg_start",
  "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,    59,    40,    41,    58,   123,   125,
      44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1230

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1230)))

#define YYTABLE_NINF -431

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-431)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      93,  2421,   136,   520,   588,   604,   113,   588,   588,    33,
     463,   588,   164,   934,    96,   197,   790,  1440,    16,   588,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,   257,
     471,   457,   519,   269,   183, -1230, -1230,   309,   261,   231,
     264,  1440,   351, -1230, -1230, -1230, -1230, -1230,   363,   363,
   -1230, -1230, -1230,    70, -1230,   536, -1230,   363,  2069, -1230,
   -1230, -1230,   363, -1230,   363,  2131,   363,  2050,   363,  2165,
     363,  1904,   363,  1153, -1230, -1230,  2199,  2032, -1230, -1230,
   -1230,   135, -1230,   372,   398,   438,   372,   381, -1230,   461,
     468,   408,   588,   588,   472,   170, -1230,   642,    60, -1230,
     511,   518, -1230, -1230,   344,   376,   548,   580,   580,   577,
     584,   591,   611,   616,   626,   634,    14, -1230, -1230, -1230,
     631,   290, -1230,   482,    43,     4,  1440, -1230,   362,   388,
     395, -1230, -1230,   406,   421,   459,   817,    59, -1230, -1230,
   -1230, -1230, -1230,  1822, -1230,  2574, -1230, -1230,   874,   712,
     750,   771, -1230,   768, -1230,   -15,   135,    29, -1230, -1230,
   -1230, -1230,   423,   446,   701,   553, -1230,   828, -1230,   495,
     170,  2599, -1230,   759,   525,   550, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230,   592,   135,   850,   825,
      29,   390, -1230,   781,   596,   843,   932,   170, -1230,   605,
     613,   639,   651,   445,   615,   729,   990,   390,   916,    76,
     886,   390,    75,   580,   418,   943,   794,   946,   799,   797,
     501,   800,   787,   498,   773,   776,   390,   770,   775,   772,
     -25,    34,   802,   766,   785,   390,   820, -1230,   685,   693,
     739,   390,   977,    29,   390, -1230, -1230,   704,   710, -1230,
     711,   982,   479, -1230,   720,   719,  1014, -1230,  1069,    29,
     734,   -52,    29,    29,  1020,   143, -1230,   749,   754, -1230,
     751,   752,   803,   580,  1041, -1230,   767,   868,   769,  1043,
     390,  1051,   390,  1050, -1230,   791,   792,   806,  1054,  1119,
   -1230,   807,   808, -1230, -1230,   980,  1138,   381, -1230, -1230,
    1140,    29,  1144, -1230, -1230,  1134,  1160,  1161,  1164, -1230,
   -1230, -1230,   250,  1166, -1230, -1230,   841,  1168, -1230,  1171,
     286, -1230, -1230,  2387,  1992,   548, -1230,   548,   548, -1230,
     378,   486,  1172,  1173, -1230, -1230,     5,  1058,  1059, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230,    14, -1230,    14,  1440,
      14,    14,  1167, -1230,  1170,  1139,  1156,   983,  1163,     4,
       4,  1162,  1169,  1440,  1440,  1440,  1440,  1440,  1175, -1230,
   -1230,  1180, -1230,   836,    57, -1230, -1230, -1230, -1230,   789,
   -1230, -1230,  1195, -1230, -1230, -1230,    36,    35, -1230,   187,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230,  1440,  1440,  1440,  1440,
    1440,  1440,  1440,  1440,  1440,  1440,  1440,  1440,  1440,   475,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,   507,
   -1230, -1230,  1196, -1230,  1440,  1183, -1230, -1230,   874,   851,
   -1230,  1440, -1230,    29,   819,   822, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230,   853,  1777, -1230,   491, -1230,   855,   849,
    1191, -1230, -1230,   -47, -1230, -1230, -1230, -1230,   739, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,   722, -1230,
     310,  1112,  1440, -1230, -1230,   310, -1230,   310, -1230, -1230,
   -1230, -1230, -1230, -1230,  1145,  1151, -1230,  1176,   870,   872,
      29,   967,   390,   580,   877, -1230,   878,  1198,    29,  1113,
      29,  1174,    29,  1178,   -51,    29,    29,   390,  1184,   881,
    1158,   889,   390,   902,   390,   385,   390,   850,   390,   903,
     904,   390,   390,   390,   906,  1142, -1230, -1230, -1230, -1230,
     390, -1230,  1177, -1230, -1230, -1230,  1221,   919,   920, -1230,
   -1230,    29, -1230,   925, -1230,   927,  1181, -1230, -1230, -1230,
     935,   937,   941,    29,   942,   944,   945, -1230, -1230,   361,
   -1230,   390, -1230,   850, -1230, -1230,   681, -1230,   580, -1230,
    1063, -1230, -1230, -1230,    29, -1230,    29, -1230,   390, -1230,
   -1230, -1230,    29, -1230,   580, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230,   544, -1230, -1230,  1297, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230,   552, -1230, -1230,  1298,
   -1230, -1230, -1230,  1283, -1230,  1289, -1230,   580, -1230, -1230,
    1293,  1294, -1230,   722, -1230, -1230, -1230, -1230,   580, -1230,
   -1230,  1295, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230,  1312,  1299,  1299,   733,   548,  1299,   548,  1299, -1230,
   -1230,    29,   580, -1230,  1303,  1308, -1230, -1230,   686, -1230,
   -1230, -1230, -1230,   116, -1230,   969, -1230,  1300, -1230, -1230,
   -1230, -1230,   199,   245,   270,   763,   295,  -261, -1230,  1440,
   -1230,  1440, -1230,  1322,   971,   974,  1038,    90,   171, -1230,
   -1230, -1230,  1320,  1318, -1230,  1948,  1948,  1948,  2610,  2610,
    1948,  1948,  1948,  1948,   661,   661,  1169,  1169, -1230,   986,
   -1230, -1230, -1230, -1230,   874, -1230,   830, -1230,   586, -1230,
    1038,  1325, -1230, -1230, -1230, -1230, -1230,   992, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230,    13,   994,   991, -1230, -1230, -1230, -1230,   580,    29,
   -1230, -1230, -1230,  1532,  1777, -1230,   580, -1230, -1230,  1323,
   -1230,   998, -1230, -1230, -1230, -1230,  1264, -1230,   390,  2599,
   -1230, -1230,  1962,    29,    29,   390, -1230, -1230,  1007,   390,
    1008,  1009, -1230, -1230,  1352,  1251,  1019,    29,  1021,    29,
    1028,    29,  1029,  1030,  1031,  1035,  1037,    29, -1230,   739,
   -1230,  1044, -1230,  1045,  1046,  1047,  1048,  1052,  1053,  1055,
   -1230, -1230,  1057,  1061,  1062, -1230,   222, -1230,    29,   676,
    1065, -1230, -1230,  1067,   185, -1230, -1230,  1049,  1078, -1230,
   -1230, -1230,  1083, -1230, -1230, -1230,    29,   617,   627,  1080,
    1086,  1087, -1230,  1198, -1230,   580,  1079,  1063, -1230, -1230,
   -1230, -1230,     5, -1230, -1230, -1230,   980, -1230, -1230,   250,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230,  1401,  1402, -1230, -1230,   739, -1230,   739,  1397, -1230,
   -1230,   739,  1299,  1410,  1299,  1439, -1230, -1230,  1328,  1331,
   -1230,  1440, -1230,  1416,  1440,  1440,  1440, -1230,  1440, -1230,
    1440,   324,  1072,  1440,  1249,  1440, -1230, -1230, -1230, -1230,
    1084,   631, -1230,  1440, -1230, -1230, -1230, -1230,   998, -1230,
   -1230, -1230,  1777,   621, -1230, -1230, -1230,  1092,  1106, -1230,
    1344, -1230,   748, -1230,   879, -1230, -1230, -1230, -1230,   580,
   -1230, -1230,  1110,  1111,  1108,  1116, -1230,  1118, -1230, -1230,
   -1230,    29, -1230,  1120, -1230,  1121, -1230,  1146, -1230, -1230,
   -1230, -1230, -1230,  1155,  1157, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230,  1159, -1230, -1230,
     390,    25,    77, -1230,  1165,   580, -1230, -1230,   554, -1230,
    1182, -1230,  1186, -1230, -1230, -1230, -1230, -1230,  1181, -1230,
    1185,  1472,  1472,  1472,  1472, -1230, -1230, -1230, -1230,  1198,
      29,  1079, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
    1490, -1230,  1495, -1230,  1499,  1500, -1230, -1230,  1105,  1494,
    1523,  1568,   508,  1440, -1230, -1230,  2599,  1188,  1197,  2599,
    1510,  1605, -1230,    24, -1230,  1505, -1230, -1230,  1201,  1440,
   -1230, -1230, -1230,  1440,  1440,  1179,    39,  1822,  1187,  1361,
   -1230,  1777, -1230,  1513,   580, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230,  1200, -1230,    23, -1230, -1230, -1230,
      29, -1230, -1230,  1206, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230,    29,    29,   390,    29, -1230,  1203,   739,
   -1230, -1230,  1205,  1207,    29, -1230, -1230,    29,  1209,   343,
   -1230,   361, -1230,  1210,  1214,  1215,  1216, -1230, -1230, -1230,
   -1230,   408,   408, -1230, -1230, -1230, -1230,  1440,  1638,  1522,
    1407,  1212, -1230,  1440,  1139,  1440, -1230,   905,  2506,   624,
   -1230, -1230,  1515,   228, -1230,  2599,  1213,  1218, -1230,  1419,
   -1230,   436, -1230, -1230,  1555,  1561,  1357,  1228, -1230,  -202,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230,   -22,    29,  1313,   287, -1230,  1230, -1230,   361,   361,
     361,   361,  1582,  1595,  1663, -1230,  1244,  1245,    11, -1230,
    1831,  1246,  1858,  1950, -1230,  1319, -1230,  1440,  1440,   405,
    1361, -1230,  1588, -1230,   206, -1230, -1230,   580,  1391, -1230,
    1252,    12,   198,    17,  1070,    29,    29,    29, -1230, -1230,
     118, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230,  1440, -1230,  1440, -1230, -1230,
   -1230, -1230,  1253,   621,  1428, -1230,     9,  1883,  1908,  1263,
    1265,  1268,  1269,  1271, -1230,  1272,   390,   793,  1423,    29,
      29, -1230,  1282, -1230,   390, -1230, -1230, -1230, -1230, -1230,
   -1230,   248,   390,    29,   390, -1230,  1285, -1230,    29,    29,
      29,  1386,    22,   168, -1230, -1230,  1286, -1230, -1230, -1230,
    1333, -1230,  1284,  1287,  1301,  1292,  1319,    85, -1230, -1230,
   -1230,   789, -1230, -1230,  1645, -1230, -1230, -1230,   359, -1230,
   -1230,  1440,  1440,  1440,  1440, -1230, -1230, -1230,  1441,  1443,
    1444,   783, -1230, -1230, -1230, -1230,  2154, -1230,    29,  1304,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230,    29,    29, -1230,
   -1230, -1230, -1230, -1230, -1230,  1440, -1230, -1230, -1230, -1230,
   -1230,  1702,   114,    85,   157,  1727,  1755,  1781,  1806,    29,
      29,    29, -1230, -1230, -1230,  1345,  1310,   390,  1349,   146,
      29,  1399,   390,    29,    29,    29,  1445,    29,   268,  1192,
    1350,   209,  1387,    29,  1363,  1388, -1230, -1230,  1329, -1230,
   -1230, -1230, -1230,  1326, -1230,  1440, -1230, -1230, -1230,  1330,
    1339,  1340,  1355, -1230, -1230, -1230,   390, -1230, -1230,    28,
      29, -1230, -1230,   145, -1230, -1230, -1230, -1230,    29, -1230,
      29, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
     390, -1230, -1230, -1230,   390, -1230,    29,   390, -1230, -1230,
    1702, -1230, -1230, -1230, -1230, -1230,     2, -1230, -1230, -1230,
   -1230,  1394, -1230, -1230, -1230, -1230, -1230, -1230, -1230,  1414,
   -1230, -1230, -1230, -1230,  1364, -1230
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    69,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   368,     0,     0,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   756,   757,   758,   759,   760,   761,
     762,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,     3,     1,     2,     0,
       0,     0,     0,     0,     0,   103,   104,     0,     0,     0,
       0,   368,     0,   718,   719,   720,   721,   722,   105,   105,
     723,   724,   725,   101,   726,     0,   728,   105,   108,   729,
     730,   731,   105,   781,   105,   108,   105,   108,   105,   108,
     105,   108,   105,   108,     5,   727,   108,   108,   255,   257,
     256,     0,    70,    69,     0,     0,    69,    71,    68,     0,
       0,   227,     0,     0,     0,     0,   254,   259,     0,   211,
       0,     0,   195,   219,     0,   191,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   351,   355,   364,   361,
     297,   370,   358,     0,     0,   354,   368,   400,     0,     0,
       0,   356,   357,     0,     0,     0,   368,     0,   359,   360,
     365,   398,   399,     0,   397,     0,   242,   241,     0,   244,
       0,     0,    34,    33,    36,     0,     0,     0,    55,    54,
      53,    52,     0,     0,    95,     0,   261,     0,    89,     0,
       0,   263,   289,   106,     0,     0,    99,    74,    79,   149,
     478,   448,   527,   656,   662,   697,     0,     0,     0,     0,
       0,    18,   153,     0,     0,     0,     0,     0,   780,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,   782,     0,     0,
       0,    18,     0,     0,    18,   783,   530,     0,     0,   536,
       0,     0,     0,   784,     0,     0,     0,   695,     0,     0,
       0,     0,     0,     0,     0,     0,   785,     0,     0,   174,
     178,     0,     0,     0,     0,   786,     0,     0,     0,     0,
      18,     0,    18,     0,   778,     0,     0,     0,     0,    30,
     779,     0,     0,   156,   155,     0,     0,    71,    65,    66,
       0,    72,     0,   248,   246,     0,     0,     0,     0,   249,
     167,   166,     0,     0,   258,   260,   259,     0,   192,     0,
     215,   187,   186,     0,     0,   191,   190,   191,   191,   647,
     191,   191,     0,     0,    19,    20,     0,     0,     0,   237,
     238,   234,   232,   233,   235,   236,   351,   370,   351,   368,
     351,   351,     0,   343,     0,   368,     0,     0,     0,   354,
     354,     0,   395,   368,   368,   368,   368,   368,     0,   314,
     315,     0,   317,     0,     0,     7,   301,   299,     9,   368,
     298,   300,   323,   321,   322,   329,     0,   334,   338,     0,
     799,   794,   795,   796,   797,   371,   798,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   801,   804,   803,   800,
     802,   805,   806,   807,   810,   808,   809,   811,   812,   813,
     814,   815,   816,   401,   402,   239,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   368,     0,
      41,    42,    43,    44,    45,    46,    47,    48,    49,     0,
      39,   245,     0,   247,   368,     0,    35,    37,     0,     0,
     134,   368,   135,    56,     0,     0,    62,    96,    97,    85,
      86,    87,   145,     0,   278,    98,     0,    51,     0,     0,
       0,   787,   791,     0,   150,   111,   133,   119,     0,   109,
      14,    16,    15,    17,    13,   110,   136,   124,   278,   125,
       0,     0,   368,   113,   123,     0,   114,     0,   121,   112,
     151,   152,   453,   479,     0,     0,   491,     0,     0,     0,
       0,     0,    18,     0,     0,   492,     0,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    18,     0,    18,     0,    18,     0,    18,     0,
       0,    18,    18,    18,     0,     0,   480,   528,   537,   531,
      18,   535,   533,   529,   539,   657,     0,     0,     0,   658,
     663,     0,   136,     0,   179,     0,   175,   678,   676,   677,
       0,     0,     0,     0,     0,     0,     0,   664,   671,   180,
     698,    18,   703,     0,   699,   713,     0,   712,     0,   716,
       0,   714,   715,   702,     0,    75,     0,    77,    18,   789,
     790,   788,     0,    29,     0,   793,   792,   161,   160,   162,
     164,   165,   163,     0,   158,   252,     0,    67,    73,    63,
     228,   231,   250,   251,   171,   172,     0,   169,   253,     0,
     188,   193,   210,     0,   217,     0,   216,     0,   194,   201,
       0,     0,   209,   278,   203,   202,   206,   207,     0,   208,
     196,     0,   200,   218,   226,   220,   223,   224,   222,   225,
     221,     0,   638,   638,     0,   191,   638,   191,   638,   639,
     717,     0,     0,    23,     0,     0,   347,   348,     0,   349,
     350,   345,   333,   428,   431,     0,   408,     0,   409,   352,
     353,   346,     0,     0,     0,     0,     0,     0,   316,   368,
     381,   368,   310,   308,     0,     0,   307,     0,     0,   362,
     335,   336,     0,     0,   363,   393,   391,   389,   386,   387,
     388,   390,   392,   394,   382,   383,   384,   385,   403,     0,
     404,   406,   407,   243,     0,   240,     0,    32,     0,    31,
       0,     0,    58,    59,    60,    61,   136,     0,    83,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,     0,     0,     0,   262,   282,    93,    94,     0,     0,
      88,    90,    50,     0,   278,   107,     0,   102,   120,   140,
     143,   154,   283,   284,   122,   132,   126,   116,    18,   285,
     117,   115,   108,     0,     0,    18,   517,   519,     0,    18,
       0,     0,   526,   493,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   485,     0,
     486,     0,   515,     0,     0,     0,     0,     0,     0,     0,
     499,   500,     0,     0,     0,   521,     0,   532,     0,     0,
       0,   660,   661,     0,   693,   675,   666,     0,     0,   670,
     665,   667,     0,   673,   674,   672,     0,     0,     0,     0,
       0,     0,   709,    21,   711,     0,   706,   710,    82,    76,
      78,    80,    25,    24,    81,   157,     0,    64,   168,     0,
     189,   214,   213,   212,   198,   205,   199,   197,   204,   477,
     637,     0,     0,   646,   655,     0,   653,     0,     0,   650,
     648,     0,   638,     0,   638,     0,    26,    27,     0,     0,
     344,   368,   417,     0,   368,   368,   368,   396,   368,   415,
     368,     0,     0,   368,   368,   368,     8,   297,   324,   330,
       0,     0,   339,   368,    40,     6,    38,    57,   146,    84,
     277,   276,   278,   368,    91,    92,   287,   280,     0,   290,
       0,   141,     0,   136,     0,   131,   118,   456,   456,     0,
     455,   449,     0,     0,     0,     0,   518,     0,   514,   508,
      22,     0,   481,     0,   487,     0,   490,     0,   495,   494,
     507,   506,   501,     0,     0,   516,   504,   496,   497,   498,
     520,   524,   503,   502,   525,   505,   522,     0,   534,   629,
      18,     0,    18,   550,     0,     0,   552,   542,    18,   538,
       0,   556,   630,   659,   669,   691,   696,   173,   175,   668,
       0,     0,     0,     0,     0,   177,   700,   701,   708,    21,
       0,   707,   159,   170,   641,   640,   654,   649,   651,   652,
       0,   642,     0,   644,     0,     0,   429,   410,     0,     0,
       0,     0,     0,   368,   366,   309,   307,     0,     0,   313,
       0,     0,   279,     0,   421,     0,   422,   423,     0,   368,
     419,   420,   418,   368,   368,     0,   368,     0,     0,   368,
     293,     0,   286,     0,   137,   138,   142,   144,   127,   128,
     129,   130,   136,   450,   465,   451,   469,   452,   454,   510,
       0,   512,   513,     0,   482,   489,   488,   509,   484,   523,
     136,   555,   543,     0,     0,    18,     0,   541,     0,     0,
     559,   554,   558,     0,     0,   548,   540,     0,   566,   684,
     176,   180,    28,     0,     0,     0,     0,   704,   705,   643,
     645,   227,   227,   414,   412,   413,   411,   368,     0,   311,
     368,     0,   405,   368,   368,   368,   368,     0,     0,     0,
     288,   294,     0,     0,   441,   424,   426,     0,   281,     0,
     139,   465,   463,   468,     0,     0,   472,     0,   483,   630,
     545,   546,   544,   547,   617,   580,   560,   617,   549,   631,
     567,     0,     0,     0,     0,   694,     0,   185,   180,   180,
     180,   180,     0,     0,     0,   367,     0,     0,     0,   337,
       0,     0,     0,     0,   435,   368,   340,   368,   368,     0,
     368,   440,     0,   467,     0,   470,   471,     0,   474,   511,
     634,     0,     0,     0,   569,     0,     0,     0,   687,   685,
      18,   679,   680,   681,   682,   683,   686,   692,   181,   182,
     183,   184,   229,   230,   416,   368,   320,   368,   318,   434,
     369,   438,     0,   368,   432,   295,     0,     0,     0,     0,
       0,     0,     0,     0,   427,     0,    18,     0,     0,     0,
       0,   466,     0,   473,    18,   476,   632,   636,   551,   620,
     618,   621,    18,     0,    18,   557,     0,   553,     0,     0,
       0,     0,     0,     0,   565,   579,     0,   147,   148,   688,
       0,   689,     0,     0,     0,     0,   368,   368,   302,   306,
     304,   368,   442,   305,   327,   325,   326,   331,     0,   437,
     436,   368,   368,   368,   368,   443,   100,   462,     0,     0,
       0,     0,   457,   461,   464,   475,     0,   622,     0,     0,
     563,   564,   562,   561,   573,   571,   570,     0,     0,   574,
     576,   577,   578,   568,   690,   368,   319,   439,   296,   433,
     342,   307,     0,   368,     0,     0,     0,     0,     0,     0,
       0,     0,    10,    11,    12,     0,     0,    18,     0,     0,
       0,     0,    18,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   635,   616,     0,   623,
     619,   572,   575,     0,   303,   368,   328,   341,   332,     0,
       0,     0,     0,   458,   459,   460,    18,   624,   615,     0,
       0,   611,   585,    18,   601,   581,   584,   582,     0,   599,
       0,   586,   588,   589,   590,   591,   592,   593,   594,   595,
      18,   605,   606,   607,    18,   583,     0,    18,   633,   312,
       0,   447,   445,   446,   444,   602,     0,   608,   609,   610,
     612,     0,   613,   598,   587,   597,   600,   603,   596,   626,
     604,   625,   614,   627,     0,   628
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1230, -1230, -1230, -1230,  -137,  -475,   -90,  -232,  -864,  -145,
    -686, -1230,   -88, -1230, -1230, -1230, -1230, -1230,  1222,   938,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
     612,  1382, -1230, -1230, -1230, -1230, -1230, -1230,  -276, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,  1220,  -100,
    1487, -1230,   252,  -440, -1230, -1230, -1230, -1230,   730,  -604,
   -1230, -1230,   293, -1230, -1230, -1230, -1230,   -77, -1230,   814,
     -54, -1230,   812, -1121,   674,  -606, -1230,  -423, -1230, -1230,
   -1230, -1230,  -132, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230,  -199, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230,   718,  1389, -1230,
   -1230, -1230, -1230,  -751,   755,   629,  1229,  1064,  1381, -1230,
     922, -1230, -1230,  -976, -1230,   382,  -176,  1001,   339,  -950,
     796, -1229, -1090,  1592, -1195,  1013,   348, -1230, -1230,  -171,
    1010, -1230, -1230, -1230, -1230,   374,   607, -1230, -1230,  -955,
   -1230,   158,   647,   -17, -1230, -1230,   505,   815,   581, -1053,
   -1230, -1230, -1230, -1230,   778, -1230, -1230,   567, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230,   557, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230,   568, -1230, -1230, -1230,  -455, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1230,   882, -1230, -1230, -1230, -1230, -1230, -1230, -1230, -1230,
   -1029
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    84,   534,  1392,   535,   376,   855,   923,
     924,   723,  1183,   654,    85,   496,   195,   499,   489,   490,
      86,   202,   203,    87,    20,    21,    22,    23,    24,    25,
     127,   342,    88,   325,    89,   331,   326,    90,   513,    91,
     516,   821,   508,    92,    93,   523,    94,    95,   214,   239,
     543,  1005,   837,   527,    96,   829,  1136,  1002,   830,   831,
     796,   797,  1288,    97,    98,   536,   240,   336,   663,   664,
     353,   676,   677,   308,   897,   309,   310,   909,    26,    27,
      28,    29,   372,    30,    31,    32,   363,   701,    33,   360,
     687,    34,   364,   346,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,   189,   492,    47,    48,
      49,    50,    51,    52,    53,    54,    55,   121,   357,    99,
     514,   100,   811,   812,   813,   998,   833,   834,   544,   824,
     815,   101,   519,  1125,  1126,  1314,   178,   422,  1374,   753,
     754,   423,  1108,   755,   424,   425,  1377,   426,  1378,   179,
     428,   429,  1316,   391,   180,   392,   401,   181,   182,   183,
    1128,   184,   463,  1106,  1129,  1216,  1217,   734,   735,  1130,
     102,  1012,   842,   103,  1142,  1332,  1274,  1223,  1143,  1145,
    1226,  1278,  1335,  1147,    56,   104,   105,   106,   107,   287,
     288,   289,   889,  1060,  1168,  1173,  1171,  1172,  1282,  1346,
    1061,  1284,  1356,  1062,  1458,  1281,  1340,  1341,  1399,  1516,
    1534,  1531,  1160,  1178,  1396,  1337,  1161,   941,    57,    58,
      59,    60,    61,    62,    63,    64,   714,   108,   109,   110,
     111,   620,  1296,  1246,  1179,  1066,   612,   613,   112,   113,
     317,   916,   917,   318,    65,   114,    66,   115,   116,   117,
     464
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     185,   421,   377,   378,   598,   278,   427,   286,   894,   294,
     898,   307,   937,   316,   373,  1367,   327,   332,  1307,   399,
    1529,   567,   569,  1105,  1368,  1369,  1370,   977,   497,   386,
     374,   375,   990,   387,   721,   374,   375,   415,  1127,   617,
     420,   418,   388,   415,   415,  -292,  1203,   418,   418,  1078,
     862,   186,   587,  1224,  -292,  -292,  -292,  -292,  1113,   187,
     502,   760,   761,   358,   211,   466,   467,   468,   469,   470,
     397,   826,   997,  1211,   415,   416,   417,   160,   418,   471,
     472,   473,   474,   475,   476,   477,   478,  1375,  1114,   479,
     415,  -291,   415,   529,   418,   969,   418,     1,  1213,   970,
    -291,  -291,  -291,  -291,  1113,   415,   416,   417,   977,   418,
    1258,   530,   531,   532,   533,   566,   128,  1285,  1286,   500,
     589,  1376,  1177,  1115,   466,   467,   468,   469,   470,  1368,
    1369,  1370,   977,   415,  1114,  1408,    67,   418,   471,   472,
     473,   474,   475,   476,   477,   478,   601,   878,   479,   402,
     525,   131,   530,   531,   532,   533,   518,   559,  1003,   414,
     415,   564,   615,  1355,   418,   621,   622,   136,   632,  1115,
     333,  1127,  1368,  1369,  1370,   977,   583,   863,   334,   530,
     531,   532,   533,   549,   991,   594,   415,   416,   417,   977,
     418,   599,   988,   911,   602,  1375,  1116,  1117,  1118,  1119,
    1120,  1121,  1122,   359,   668,   350,   588,   466,   467,   468,
     469,   470,  1315,   351,   147,  1187,  1123,  1363,   700,  1124,
     561,   471,   472,   473,   474,   475,   476,   477,   478,  1376,
     645,   479,   647,   711,  1312,   712,   713,   415,   716,   718,
    1225,   418,  1116,  1117,  1118,  1119,  1120,  1121,  1122,   398,
    1268,  1263,   828,   466,   467,   468,   469,   470,   942,  1410,
    1269,   953,  1123,   955,   205,  1124,  1287,   471,   472,   473,
     474,   475,   476,   477,   478,  1457,   191,   479,   466,   467,
     468,   469,   470,   415,   209,  1285,  1286,   418,   204,   682,
     618,   619,   471,   472,   473,   474,   475,   476,   477,   478,
    1501,   590,   479,   466,   467,   468,   469,   470,  1163,  1164,
    1127,  1326,   827,  1315,   393,   148,  1135,   471,   472,   473,
     474,   475,   476,   477,   478,   415,   562,   479,   206,   418,
    1360,   851,   466,   467,   468,   469,   470,  1365,   207,  1517,
    1518,  1342,   674,   498,  1165,   835,   471,   472,   473,   474,
     475,   476,   477,   478,   208,  1362,   479,  1521,  1127,   624,
    1166,  1530,   722,   683,  1371,   400,   791,  1308,  1372,   389,
     212,  1338,   728,   210,   188,   390,  1347,   501,   733,  1204,
     997,  1490,   213,   501,   501,   675,   742,   743,   744,   745,
     746,  1420,   122,   762,  -292,   366,   758,   366,  -292,   759,
     684,   338,   756,   836,   913,   415,   914,   685,   836,   418,
     836,  1127,  1127,   750,   419,  1327,  1328,   751,   686,  1329,
    1330,   715,   922,   848,   530,   531,   532,   533,   216,   565,
     501,   856,   501,   858,  1480,   860,   374,   375,   864,   865,
    -291,   339,   906,   503,  -291,   501,   341,  1467,  1220,   765,
     766,   767,   768,   769,   770,   771,   772,   773,   774,   775,
     776,   777,   898,   367,   343,  1463,   922,  1411,  1127,  1465,
    1412,   344,   850,   501,   893,   349,   961,   786,   907,   504,
     505,  1343,   118,   119,   790,   345,   902,   866,   625,   626,
     957,   192,   871,   335,   873,  1319,   877,  1090,   879,  1092,
     501,   882,   883,   884,  1344,   366,   120,   918,  1502,   919,
     887,  1503,  1371,   193,   361,   921,   466,   467,   468,   469,
     470,   362,   908,    68,   194,   839,   419,   368,   352,   717,
     471,   472,   473,   474,   475,   476,   477,   478,  1221,   568,
     479,   910,   933,  1065,   393,  1003,   393,   763,   393,   393,
     764,  1320,  1321,    69,  1397,  1241,  1229,  1345,   920,   964,
     198,    70,  1398,   365,    71,  1331,   196,   366,   509,   415,
     510,   511,   197,   418,  1242,    72,  1046,   501,  1291,   199,
     379,   421,   421,   952,   956,   954,   994,   380,   530,   531,
     532,   533,   427,  1034,   381,   132,   133,    73,   374,   375,
      74,   200,    75,    76,   217,   965,  1322,   118,   119,   218,
      77,  1323,  1243,   874,   382,   816,   817,   818,   819,   383,
     420,   420,   219,   501,   122,  1292,  1293,  1294,  1295,   384,
     966,   120,   466,   467,   468,   469,   470,   385,    78,   537,
    1113,   778,    79,   875,   876,   395,   471,   472,   473,   474,
     475,   476,   477,   478,    80,   968,   479,   512,   123,   220,
     394,   354,   355,   201,   779,   501,   124,   125,   126,  1086,
    1114,  1087,   780,    81,  1244,  1089,    82,   781,   782,   554,
     555,  1000,   995,  1079,  1103,   356,   538,   539,   396,   477,
     478,   545,   369,   479,   466,   467,   468,   469,   470,   374,
     375,   912,  1245,   370,   371,  1115,  1013,  1014,   471,   472,
     473,   474,   475,   476,   477,   478,  1423,   403,   479,  1424,
    1023,  1071,  1025,  1072,  1027,   129,   130,   491,   134,   135,
    1033,  1073,   971,  1074,   972,   337,   943,   190,   340,   575,
     576,   832,  1011,   404,   221,   501,   579,   580,  1006,  1047,
     405,  1048,   944,   493,   509,  1015,   510,   511,  1247,  1017,
     726,   406,   727,  1049,   729,   730,   374,   375,  1134,  1070,
     922,   466,   467,   468,   469,   470,   407,  1146,  1116,  1117,
    1118,  1119,  1120,  1121,  1122,   471,   472,   473,   474,   475,
     476,   477,   478,   494,  1222,   479,  1003,   840,  1123,   841,
     506,  1124,   156,   542,   157,   158,   159,   160,   161,   162,
     222,   607,   608,   945,   408,   163,   164,   752,   165,  1050,
     166,  1432,  1433,  1434,   537,  1298,  1299,  1300,  1301,   495,
     156,   507,   157,   158,   159,   160,   161,   162,   466,   467,
     468,   469,   470,   163,   164,   820,   165,   515,   166,   517,
     347,   348,   471,   472,   473,   474,   475,   476,   477,   478,
     354,   355,   479,   520,   149,   223,   783,   784,  1197,   526,
     224,   538,   539,   167,    83,  1174,   540,   792,   793,   168,
     794,   795,   541,   521,  1153,   225,   799,   800,   801,   802,
     803,   804,   805,  1235,   806,   807,   808,   809,   810,   150,
     151,   167,   922,   925,   926,  1051,   528,   168,   522,   501,
    1170,   928,   929,   466,   467,   468,   469,   470,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   471,   472,   473,
     474,   475,   476,   477,   478,   169,   170,   479,   547,   152,
     153,   154,   155,  1188,   733,   986,   784,  1098,  1099,  1100,
     524,  1101,   548,  1102,  1473,  1474,  1475,  1052,  1109,   550,
    1162,   946,  1167,   169,   170,   557,  1111,   551,  1175,   556,
     171,   172,   409,   410,   411,   412,  1138,  1139,  1140,  1141,
    -291,  1053,  1266,  1054,  1184,  1185,  1186,   173,   542,  1055,
     174,  1056,  1252,  1253,   175,  1057,  1058,   552,   171,   172,
     409,   410,   411,   412,  1388,  1389,   739,   740,   947,   553,
     558,   560,   563,  1227,   570,   173,   571,   572,   174,   573,
     578,   581,   175,   948,   574,   584,  1230,  1231,   582,  1233,
     635,   577,   585,   591,   586,  1059,   592,  1238,   595,   596,
    1239,   949,   960,   137,   138,  1333,   466,   467,   468,   469,
     470,   597,   139,   593,   657,   950,   951,   600,   603,   606,
     471,   472,   473,   474,   475,   476,   477,   478,   604,   605,
     479,   140,   658,   659,   609,  1232,   141,   610,   142,   143,
     466,   467,   468,   469,   470,   611,  1198,   660,   661,   614,
     662,   623,   616,   636,   471,   472,   473,   474,   475,   476,
     477,   478,  1207,   627,   479,  1289,  1208,  1209,   628,   629,
     630,   631,  1215,   466,   467,   468,   469,   470,   633,   967,
     644,   634,   646,   643,   648,   652,   637,   471,   472,   473,
     474,   475,   476,   477,   478,   638,  1339,   479,  1339,   653,
    1373,   665,   144,   667,   176,   649,   650,   669,  1357,  1358,
    1359,   177,   156,   670,   157,   158,   159,   160,   161,   162,
     651,   655,   656,   671,   672,   163,   164,   673,   165,   678,
     166,   680,   176,   298,   681,   719,   720,   724,   725,   177,
    1254,   731,   736,  1109,   985,   732,  1260,   733,  1262,   737,
     738,   741,  1391,  1393,   747,   748,   749,   227,   300,   785,
    1361,   479,   757,   787,   823,   789,  1401,   798,   145,   822,
     825,  1404,  1405,  1406,   838,  1409,   843,   312,   639,   640,
     641,   642,   844,   167,   846,   845,   847,   849,   854,   168,
     228,   852,   853,   229,   857,   868,  1387,   230,   231,   869,
     890,   233,   234,   870,  1395,   859,  1373,   235,  1373,   861,
    1317,  1318,  1400,  1215,  1402,   867,   872,   880,   881,  1264,
     885,  1459,   156,   886,   157,   158,   159,   160,   161,   162,
    1461,  1462,   888,   891,   892,   163,   164,   752,   165,   895,
     166,   896,   236,   146,   298,   169,   170,   237,   915,   899,
    1109,   900,  1391,  1391,  1391,   901,   903,   313,   904,   905,
     927,   930,   931,  1482,   932,  1348,  1485,  1486,  1487,   215,
    1489,  1491,   934,   935,   938,   939,  1505,   226,   958,   940,
     171,   172,   241,   959,   242,   962,   279,   963,   290,   973,
     295,   974,   311,   167,   975,   980,   981,   173,  1113,   168,
     174,   983,  1519,  1520,   175,   987,   989,  1478,   992,   993,
    1001,  1523,  1484,  1524,  1421,  1349,  1350,  1351,  1003,  1352,
    1004,  1016,  1018,  1019,  1425,  1426,  1427,  1428,  1114,  1527,
    1353,  1020,  1021,  1022,   156,  1024,   157,   158,   159,   160,
     161,   162,  1026,  1028,  1029,  1030,  1515,   163,   164,  1031,
     165,  1032,   166,  1522,   976,   169,   170,  1080,  1035,  1036,
    1037,  1038,  1039,  1115,  1084,  1085,  1040,  1041,  1067,  1042,
    1525,  1043,  1088,  1091,  1526,  1044,  1045,  1528,   314,  1063,
     156,  1064,   157,   158,   159,   160,   161,   162,  1104,  1354,
     171,   172,  1068,   163,   164,  1257,   165,  1069,   166,  1075,
    1076,  1077,  1093,  1097,  1110,   167,  1131,   173,  1510,  1094,
     174,   168,  1095,   156,   175,   157,   158,   159,   160,   161,
     162,  1193,  1132,  1133,  1148,  1149,   163,   164,  1150,   165,
    1151,   166,  1152,  1169,  1154,  1155,  1116,  1117,  1118,  1119,
    1120,  1121,  1122,  1492,  1493,  1494,  1495,  1496,  1497,  1498,
    1499,   167,  1182,  1189,   176,  -430,  1123,   168,  1190,  1124,
    1156,   177,   466,   467,   468,   469,   470,   169,   170,  1157,
    1177,  1158,   315,  1159,  1191,  1192,   471,   472,   473,   474,
     475,   476,   477,   478,   167,  1201,   479,  1205,  1219,  1256,
     168,   466,   467,   468,   469,   470,  1176,  1267,  1210,  1181,
    1272,  1214,   171,   172,  1199,   471,   472,   473,   474,   475,
     476,   477,   478,   169,   170,   479,  1206,  1200,  1222,   173,
    1228,  1234,   174,  1236,  1248,  1237,   175,  1240,  1249,  1250,
    1251,  1259,  1271,  1270,  1275,  1277,   466,   467,   468,   469,
     470,  1276,  1279,  1290,  1297,  1302,   169,   170,   171,   172,
     471,   472,   473,   474,   475,   476,   477,   478,  1303,  1305,
     479,  1306,  1310,  1325,   176,   173,  1334,  1366,   174,  1364,
    1336,   177,   175,   466,   467,   468,   469,   470,  1381,  1407,
    1382,   171,   172,  1383,  1384,  1385,  1386,   471,   472,   473,
     474,   475,   476,   477,   478,  1390,  1394,   479,   173,  1403,
    1413,   174,  1414,  1416,  1415,   175,   466,   467,   468,   469,
     470,  1418,  1422,  1476,  1429,  1417,  1430,  1431,  1460,  1479,
     471,   472,   473,   474,   475,   476,   477,   478,  1477,  1483,
     479,   466,   467,   468,   469,   470,  1500,  1313,  1488,  1507,
    1504,  1506,  1509,  1508,  1511,   471,   472,   473,   474,   475,
     476,   477,   478,  1512,  1513,   479,   799,   800,   801,   802,
     803,   804,   805,  1532,   806,   807,   808,   809,   810,  1514,
     466,   467,   468,   469,   470,  -425,   176,  1533,  1535,   666,
     788,   546,   984,   177,   471,   472,   473,   474,   475,   476,
     477,   478,  1481,  1137,   479,   466,   467,   468,   469,   470,
    1082,  1083,  1180,   814,   702,   679,   999,  1112,  1419,   471,
     472,   473,   474,   475,   476,   477,   478,   936,   978,   479,
    1218,  1466,   176,   466,   467,   468,   469,   470,   413,   177,
    1107,   979,  1468,   982,  1212,  1324,  1096,   471,   472,   473,
     474,   475,   476,   477,   478,  1261,  1144,   479,  1273,   466,
     467,   468,   469,   470,  1283,   176,     0,  1280,     0,  1081,
       0,     0,   177,   471,   472,   473,   474,   475,   476,   477,
     478,     0,     0,   479,   466,   467,   468,   469,   470,     0,
       0,     0,     0,     0,     0,     0,     0,   430,   471,   472,
     473,   474,   475,   476,   477,   478,     0,     0,   479,   466,
     467,   468,   469,   470,     0,     0,     0,     0,     0,     0,
    1194,     0,     0,   471,   472,   473,   474,   475,   476,   477,
     478,     0,     0,   479,     0,     0,   466,   467,   468,   469,
     470,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
     471,   472,   473,   474,   475,   476,   477,   478,   996,     0,
     479,   466,   467,   468,   469,   470,     0,   431,   432,     0,
     433,   434,     0,     0,     0,   471,   472,   473,   474,   475,
     476,   477,   478,     0,     0,   479,   466,   467,   468,   469,
     470,     0,     0,     0,  1196,     0,   435,     0,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,     0,
     479,   799,   800,   801,   802,   803,   804,   805,   227,   806,
     807,   808,   809,   810,     0,   430,  -431,  -431,  -431,     0,
     436,  1202,     0,     0,     0,     0,     0,     0,     0,   296,
    -431,  -431,  -431,  -431,   475,   476,   477,   478,     0,     0,
     479,   228,     0,     0,   229,     0,     0,     0,   230,   231,
       0,   297,   233,   234,  1255,   703,     0,     0,   235,     0,
       0,     0,     0,     0,     0,     0,   227,   298,     0,   437,
     438,   704,   439,   440,   441,   442,   443,   444,   445,  1304,
       0,     0,     0,     0,     0,   431,   432,     0,   433,   434,
       0,   299,   300,   236,     0,     0,     0,     0,   237,   228,
       0,     0,   229,     0,     0,     0,   230,   231,     0,  1007,
     233,   234,     0,     0,     0,     0,   235,     0,  1464,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   705,
       0,     0,     0,     0,   706,   707,   227,     0,     0,     0,
       0,     0,   708,  1469,     0,   455,   456,     0,   436,     0,
       0,   236,     0,     0,   227,     0,   237,     0,   457,   458,
     459,   460,   328,     0,     0,     0,     0,     0,     0,   228,
     709,  1470,   229,   227,     0,     0,   230,   231,     0,     0,
     233,   234,     0,     0,     0,     0,   235,   228,     0,     0,
     229,     0,     0,     0,   230,   231,     0,  1471,   233,   234,
       0,     0,     0,   329,   235,     0,   228,     0,   710,   229,
       0,     0,     0,   230,   231,     0,   232,   233,   234,     0,
       0,   236,  1472,   235,     0,     0,   237,     0,     0,   461,
     462,     0,     0,     0,     0,   227,     0,  1008,  1009,   236,
     243,     0,     0,     0,   237,  1309,     0,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,     0,   236,     0,
       0,     0,     0,   237,   301,     0,     0,     0,   228,   227,
       0,   229,  1311,   455,   456,   230,   231,   244,  1435,   233,
     234,     0,     0,     0,     0,   235,   457,   458,   459,   460,
       0,   245,     0,     0,   246,     0,   247,  1379,     0,   302,
     303,   304,   228,   227,     0,   229,     0,     0,   305,   230,
     231,     0,     0,   233,   234,     0,     0,   298,     0,   235,
     236,     0,  1380,   306,     0,   237,     0,   319,   320,   321,
       0,   322,   323,     0,     0,   248,   228,     0,     0,   229,
       0,     0,   300,   230,   231,     0,   249,   233,   234,     0,
       0,     0,     0,   235,   236,     0,     0,   461,   462,   237,
       0,     0,     0,     0,     0,  1436,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1010,   250,     0,     0,   280,     0,     0,   236,     0,
     281,   282,   283,   237,     0,     0,     0,     0,     0,   251,
       0,     0,     0,     0,     0,     0,   252,   253,     0,   254,
       0,   255,   256,     0,   257,   258,     0,   259,     0,     0,
     260,   261,  1437,   262,     0,  1438,  1439,   284,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   263,   264,     0,
       0,     0,   265,     0,   266,   267,     0,   268,     0,  1440,
     688,   330,   269,     0,     0,     0,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   374,   375,     0,     0,   285,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1441,     0,     0,     0,     0,   238,     0,
     689,     0,     0,     0,     0,  1442,     0,  1443,     0,  1444,
    1445,  1446,  1447,  1448,  1449,     0,     0,     0,     0,     0,
    1450,     0,     0,     0,  1451,  1452,     0,     0,  1453,     0,
       0,     0,     0,     0,   690,     4,     0,     0,     0,   691,
       0,  1454,     0,     0,     0,     0,   692,   693,     0,  1455,
       0,     0,     0,     0,     0,     0,     0,     5,     6,   694,
     277,     0,     0,     0,     0,   291,   292,     0,   695,   696,
     697,   698,     0,   699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1456,   466,   467,   468,   469,   470,     0,
       7,     8,     0,     0,   293,     0,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,     0,   479,     0,
       0,     9,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    10,     0,     0,    11,     0,    12,   324,     0,
       0,     0,    13,     0,     0,     0,     0,    14,    15,    16,
       0,     0,     0,     0,    17,    18,    19,   465,     0,     0,
       0,     0,   466,   467,   468,   469,   470,     0,     0,     0,
       0,     0,     0,     0,   542,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,     0,   479,   466,   467,   468,
     469,   470,     0,     0,     0,     0,     0,     0,   466,   467,
     468,   471,   472,   473,   474,   475,   476,   477,   478,     0,
       0,   479,   471,   472,   473,   474,   475,   476,   477,   478,
       0,     0,   479,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1265
};

static const yytype_int16 yycheck[] =
{
      17,   177,   147,   148,   280,   105,   177,   107,   612,   109,
     616,   111,   698,   113,   146,     6,   116,   117,     7,    15,
      18,   253,   254,   973,    15,    16,    17,    18,    43,    15,
      18,    19,    19,    19,    29,    18,    19,    15,   993,    91,
     177,    19,    28,    15,    15,     6,    22,    19,    19,   913,
     101,    35,    77,    30,    15,    16,    17,    18,    19,    43,
     197,    26,    27,     3,    81,     8,     9,    10,    11,    12,
      27,   118,   823,  1126,    15,    16,    17,    18,    19,    22,
      23,    24,    25,    26,    27,    28,    29,  1316,    49,    32,
      15,     6,    15,   230,    19,   356,    19,     4,  1127,   360,
      15,    16,    17,    18,    19,    15,    16,    17,    18,    19,
    1200,    34,    35,    36,    37,   252,     3,   139,   140,   196,
      86,  1316,   324,    84,     8,     9,    10,    11,    12,    15,
      16,    17,    18,    15,    49,   113,     0,    19,    22,    23,
      24,    25,    26,    27,    28,    29,   283,   587,    32,   166,
     227,   118,    34,    35,    36,    37,   210,   247,   360,   176,
      15,   251,   299,  1284,    19,   302,   303,     3,   313,    84,
      35,  1126,    15,    16,    17,    18,   266,   228,    43,    34,
      35,    36,    37,   237,   171,   275,    15,    16,    17,    18,
      19,   281,   796,   633,   284,  1424,   157,   158,   159,   160,
     161,   162,   163,   143,   341,    35,   231,     8,     9,    10,
      11,    12,  1265,    43,   118,  1079,   177,  1307,   363,   180,
     144,    22,    23,    24,    25,    26,    27,    28,    29,  1424,
     320,    32,   322,   365,  1263,   367,   368,    15,   370,   371,
     217,    19,   157,   158,   159,   160,   161,   162,   163,   206,
      22,  1206,   528,     8,     9,    10,    11,    12,   713,    91,
      32,   716,   177,   718,    81,   180,   288,    22,    23,    24,
      25,    26,    27,    28,    29,  1396,    19,    32,     8,     9,
      10,    11,    12,    15,    20,   139,   140,    19,    19,     3,
     342,   343,    22,    23,    24,    25,    26,    27,    28,    29,
      91,   267,    32,     8,     9,    10,    11,    12,   283,   284,
    1265,   105,   359,  1366,   156,   118,  1002,    22,    23,    24,
      25,    26,    27,    28,    29,    15,   250,    32,    19,    19,
     212,   563,     8,     9,    10,    11,    12,  1313,    77,   311,
     312,   143,    92,   358,   319,    35,    22,    23,    24,    25,
      26,    27,    28,    29,   123,  1305,    32,   212,  1313,   216,
     283,   359,   357,    77,   355,   361,   503,   356,   359,   355,
      19,   359,   389,   109,   358,   361,   359,   355,   395,   355,
    1131,   113,    19,   355,   355,   135,   403,   404,   405,   406,
     407,  1367,    20,   358,   355,    19,   360,    19,   359,   363,
     114,     3,   419,   540,   636,    15,   638,   121,   545,    19,
     547,  1366,  1367,   356,   355,   209,   210,   360,   132,   213,
     214,    43,   654,   560,    34,    35,    36,    37,   358,   354,
     355,   568,   355,   570,   288,   572,    18,    19,   575,   576,
     355,     3,    81,    20,   359,   355,    65,  1423,  1134,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,  1068,    87,     3,  1415,   698,   299,  1423,   355,
     302,     3,   562,   355,   611,     3,   360,   494,   117,    56,
      57,   283,    19,    20,   501,    77,   623,   577,   345,   346,
     722,    20,   582,   358,   584,    90,   586,   952,   588,   954,
     355,   591,   592,   593,   306,    19,    43,   644,   299,   646,
     600,   302,   355,    42,     3,   652,     8,     9,    10,    11,
      12,     3,   161,     3,    53,   542,   355,   151,   358,    43,
      22,    23,    24,    25,    26,    27,    28,    29,  1142,   121,
      32,   631,   687,   358,   386,   360,   388,   360,   390,   391,
     363,   146,   147,    33,   306,   212,  1160,   359,   648,   360,
      41,    41,   314,   219,    44,   359,   109,    19,    15,    15,
      17,    18,   115,    19,   231,    55,   354,   355,   291,    60,
       3,   757,   758,   715,   721,   717,   818,     3,    34,    35,
      36,    37,   763,   869,     3,   132,   133,    77,    18,    19,
      80,    82,    82,    83,    68,   360,   201,    19,    20,    73,
      90,   206,   269,   228,     3,   124,   125,   126,   127,     3,
     757,   758,    86,   355,    20,   338,   339,   340,   341,     3,
     360,    43,     8,     9,    10,    11,    12,     3,   118,    43,
      19,   166,   122,   258,   259,   355,    22,    23,    24,    25,
      26,    27,    28,    29,   134,   360,    32,   104,    54,   123,
      29,    19,    20,   144,   189,   355,    62,    63,    64,   945,
      49,   947,   197,   153,   331,   951,   156,   202,   203,   234,
     235,   826,   819,   915,   360,    43,    90,    91,   206,    28,
      29,    95,   316,    32,     8,     9,    10,    11,    12,    18,
      19,    20,   359,   327,   328,    84,   843,   844,    22,    23,
      24,    25,    26,    27,    28,    29,   357,   355,    32,   360,
     857,   104,   859,   106,   861,     7,     8,    15,    10,    11,
     867,   104,   749,   106,   751,   123,     3,    19,   126,   238,
     239,    19,   842,   355,   208,   355,   248,   249,   838,   886,
     355,   888,    19,     3,    15,   845,    17,    18,  1181,   849,
     386,   355,   388,    87,   390,   391,    18,    19,    20,   906,
    1002,     8,     9,    10,    11,    12,   355,  1009,   157,   158,
     159,   160,   161,   162,   163,    22,    23,    24,    25,    26,
      27,    28,    29,    22,   358,    32,   360,   545,   177,   547,
     354,   180,    13,   207,    15,    16,    17,    18,    19,    20,
     274,   332,   333,    80,   355,    26,    27,    28,    29,   143,
      31,    38,    39,    40,    43,  1248,  1249,  1250,  1251,    61,
      13,   130,    15,    16,    17,    18,    19,    20,     8,     9,
      10,    11,    12,    26,    27,   354,    29,    19,    31,   354,
     132,   133,    22,    23,    24,    25,    26,    27,    28,    29,
      19,    20,    32,   104,    74,   329,   359,   360,   360,    19,
     334,    90,    91,    84,   354,   321,    95,    58,    59,    90,
      58,    59,   101,   358,  1021,   349,   164,   165,   166,   167,
     168,   169,   170,  1169,   172,   173,   174,   175,   176,   109,
     110,    84,  1134,   359,   360,   229,    81,    90,   358,   355,
    1055,   359,   360,     8,     9,    10,    11,    12,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    22,    23,    24,
      25,    26,    27,    28,    29,   146,   147,    32,    95,   149,
     150,   151,   152,  1080,   961,   359,   360,   964,   965,   966,
     358,   968,    20,   970,  1429,  1430,  1431,   281,   975,   354,
    1050,   228,  1052,   146,   147,   236,   983,   354,  1058,   354,
     181,   182,   183,   184,   185,   186,    97,    98,    99,   100,
     359,   305,   358,   307,  1072,  1073,  1074,   198,   207,   313,
     201,   315,  1191,  1192,   205,   319,   320,   358,   181,   182,
     183,   184,   185,   186,   211,   212,   399,   400,   275,   358,
      20,    95,   126,  1150,    71,   198,   222,    71,   201,   220,
     233,   248,   205,   290,   227,   255,  1163,  1164,   252,  1166,
     162,   231,   257,   231,   262,   359,   270,  1174,   218,   354,
    1177,   308,   356,   109,   110,  1277,     8,     9,    10,    11,
      12,   358,   118,   268,    74,   322,   323,    80,   354,    77,
      22,    23,    24,    25,    26,    27,    28,    29,   358,   358,
      32,   137,    92,    93,   354,  1165,   142,   358,   144,   145,
       8,     9,    10,    11,    12,    71,  1103,   107,   108,    20,
     110,    71,   358,   225,    22,    23,    24,    25,    26,    27,
      28,    29,  1119,   354,    32,  1242,  1123,  1124,   354,   358,
     358,   308,  1129,     8,     9,    10,    11,    12,    77,   356,
      77,   354,    71,   354,    74,    71,   258,    22,    23,    24,
      25,    26,    27,    28,    29,   267,  1281,    32,  1283,    20,
    1316,     3,   208,     3,   355,   354,   354,     3,  1285,  1286,
    1287,   362,    13,    19,    15,    16,    17,    18,    19,    20,
     354,   354,   354,     3,     3,    26,    27,     3,    29,     3,
      31,     3,   355,   103,     3,     3,     3,   119,   119,   362,
    1197,    14,    26,  1200,   354,    15,  1203,  1204,  1205,   206,
      27,    29,  1329,  1330,    19,    15,   360,    44,   128,     3,
    1290,    32,     7,    20,   355,   354,  1343,   354,   274,   354,
      19,  1348,  1349,  1350,   102,  1352,    71,    64,   350,   351,
     352,   353,    71,    84,   354,    49,   354,   260,    30,    90,
      77,   354,   354,    80,   121,   354,  1326,    84,    85,    81,
      19,    88,    89,   354,  1334,    71,  1422,    94,  1424,    71,
    1267,  1268,  1342,  1270,  1344,    71,   354,   354,   354,   354,
     354,  1398,    13,   121,    15,    16,    17,    18,    19,    20,
    1407,  1408,    95,   354,   354,    26,    27,    28,    29,   354,
      31,   354,   129,   349,   103,   146,   147,   134,   225,   354,
    1307,   354,  1429,  1430,  1431,   354,   354,   144,   354,   354,
       3,     3,    19,  1440,    15,   235,  1443,  1444,  1445,    89,
    1447,  1448,    19,    19,    19,     3,  1453,    97,    15,    20,
     181,   182,   102,    15,   104,   356,   106,    27,   108,     7,
     110,   360,   112,    84,   360,    15,    18,   198,    19,    90,
     201,   355,  1479,  1480,   205,    20,   354,  1437,   354,   358,
      27,  1488,  1442,  1490,  1371,   285,   286,   287,   360,   289,
      96,   354,   354,   354,  1381,  1382,  1383,  1384,    49,  1506,
     300,    19,   121,   354,    13,   354,    15,    16,    17,    18,
      19,    20,   354,   354,   354,   354,  1476,    26,    27,   354,
      29,   354,    31,  1483,   356,   146,   147,   318,   354,   354,
     354,   354,   354,    84,     3,     3,   354,   354,   359,   354,
    1500,   354,    15,     3,  1504,   354,   354,  1507,   265,   354,
      13,   354,    15,    16,    17,    18,    19,    20,   356,   359,
     181,   182,   354,    26,    27,    28,    29,   354,    31,   359,
     354,   354,     3,    27,   360,    84,   354,   198,  1465,   121,
     201,    90,   121,    13,   205,    15,    16,    17,    18,    19,
      20,   356,   356,   119,   354,   354,    26,    27,   360,    29,
     354,    31,   354,   308,   354,   354,   157,   158,   159,   160,
     161,   162,   163,   291,   292,   293,   294,   295,   296,   297,
     298,    84,    20,     3,   355,   356,   177,    90,     3,   180,
     354,   362,     8,     9,    10,    11,    12,   146,   147,   354,
     324,   354,   359,   354,    15,    15,    22,    23,    24,    25,
      26,    27,    28,    29,    84,    15,    32,    22,    15,     7,
      90,     8,     9,    10,    11,    12,   354,    22,   359,   354,
     121,   354,   181,   182,   356,    22,    23,    24,    25,    26,
      27,    28,    29,   146,   147,    32,   355,   360,   358,   198,
     354,   358,   201,   358,   354,   358,   205,   358,   354,   354,
     354,   359,   354,   360,    19,   218,     8,     9,    10,    11,
      12,    20,   354,   270,   354,     3,   146,   147,   181,   182,
      22,    23,    24,    25,    26,    27,    28,    29,     3,   355,
      32,   356,   356,    15,   355,   198,   215,   179,   201,   356,
     358,   362,   205,     8,     9,    10,    11,    12,   355,   233,
     355,   181,   182,   355,   355,   354,   354,    22,    23,    24,
      25,    26,    27,    28,    29,   212,   354,    32,   198,   354,
     354,   201,   309,   356,   360,   205,     8,     9,    10,    11,
      12,   359,     7,   308,   213,   354,   213,   213,   354,   310,
      22,    23,    24,    25,    26,    27,    28,    29,   358,   270,
      32,     8,     9,    10,    11,    12,   326,   358,   233,   291,
     293,   318,   356,   354,   354,    22,    23,    24,    25,    26,
      27,    28,    29,   354,   354,    32,   164,   165,   166,   167,
     168,   169,   170,   309,   172,   173,   174,   175,   176,   354,
       8,     9,    10,    11,    12,   354,   355,   303,   354,   337,
     498,   234,   784,   362,    22,    23,    24,    25,    26,    27,
      28,    29,  1439,  1003,    32,     8,     9,    10,    11,    12,
     926,   929,  1068,   514,   363,   356,   824,   992,  1366,    22,
      23,    24,    25,    26,    27,    28,    29,   693,   757,    32,
    1131,  1422,   355,     8,     9,    10,    11,    12,   176,   362,
     974,   758,  1424,   763,  1127,  1270,   961,    22,    23,    24,
      25,    26,    27,    28,    29,  1204,  1008,    32,  1221,     8,
       9,    10,    11,    12,  1237,   355,    -1,  1229,    -1,   917,
      -1,    -1,   362,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
     356,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,
      22,    23,    24,    25,    26,    27,    28,    29,   356,    -1,
      32,     8,     9,    10,    11,    12,    -1,    75,    76,    -1,
      78,    79,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,   356,    -1,   104,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,   164,   165,   166,   167,   168,   169,   170,    44,   172,
     173,   174,   175,   176,    -1,     5,     8,     9,    10,    -1,
     138,   356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    77,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,
      -1,    87,    88,    89,   356,     3,    -1,    -1,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,   103,    -1,   187,
     188,    19,   190,   191,   192,   193,   194,   195,   196,   356,
      -1,    -1,    -1,    -1,    -1,    75,    76,    -1,    78,    79,
      -1,   127,   128,   129,    -1,    -1,    -1,    -1,   134,    77,
      -1,    -1,    80,    -1,    -1,    -1,    84,    85,    -1,    87,
      88,    89,    -1,    -1,    -1,    -1,    94,    -1,   356,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    77,
      -1,    -1,    -1,    -1,    82,    83,    44,    -1,    -1,    -1,
      -1,    -1,    90,   356,    -1,   263,   264,    -1,   138,    -1,
      -1,   129,    -1,    -1,    44,    -1,   134,    -1,   276,   277,
     278,   279,    70,    -1,    -1,    -1,    -1,    -1,    -1,    77,
     118,   356,    80,    44,    -1,    -1,    84,    85,    -1,    -1,
      88,    89,    -1,    -1,    -1,    -1,    94,    77,    -1,    -1,
      80,    -1,    -1,    -1,    84,    85,    -1,   356,    88,    89,
      -1,    -1,    -1,   111,    94,    -1,    77,    -1,   156,    80,
      -1,    -1,    -1,    84,    85,    -1,    87,    88,    89,    -1,
      -1,   129,   356,    94,    -1,    -1,   134,    -1,    -1,   347,
     348,    -1,    -1,    -1,    -1,    44,    -1,   215,   216,   129,
      49,    -1,    -1,    -1,   134,   354,    -1,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   129,    -1,
      -1,    -1,    -1,   134,   300,    -1,    -1,    -1,    77,    44,
      -1,    80,   354,   263,   264,    84,    85,    86,    64,    88,
      89,    -1,    -1,    -1,    -1,    94,   276,   277,   278,   279,
      -1,   100,    -1,    -1,   103,    -1,   105,   354,    -1,   335,
     336,   337,    77,    44,    -1,    80,    -1,    -1,   344,    84,
      85,    -1,    -1,    88,    89,    -1,    -1,   103,    -1,    94,
     129,    -1,   354,   359,    -1,   134,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    -1,   144,    77,    -1,    -1,    80,
      -1,    -1,   128,    84,    85,    -1,   155,    88,    89,    -1,
      -1,    -1,    -1,    94,   129,    -1,    -1,   347,   348,   134,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   359,   191,    -1,    -1,   275,    -1,    -1,   129,    -1,
     280,   281,   282,   134,    -1,    -1,    -1,    -1,    -1,   208,
      -1,    -1,    -1,    -1,    -1,    -1,   215,   216,    -1,   218,
      -1,   220,   221,    -1,   223,   224,    -1,   226,    -1,    -1,
     229,   230,   208,   232,    -1,   211,   212,   317,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,    -1,
      -1,    -1,   251,    -1,   253,   254,    -1,   256,    -1,   235,
       3,   359,   261,    -1,    -1,    -1,   265,   266,    -1,   268,
     269,    -1,   271,   272,   273,    18,    19,    -1,    -1,   359,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,   359,    -1,
      43,    -1,    -1,    -1,    -1,   281,    -1,   283,    -1,   285,
     286,   287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,   300,   301,    -1,    -1,   304,    -1,
      -1,    -1,    -1,    -1,    77,    44,    -1,    -1,    -1,    82,
      -1,   317,    -1,    -1,    -1,    -1,    89,    90,    -1,   325,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,   102,
     359,    -1,    -1,    -1,    -1,   330,   331,    -1,   111,   112,
     113,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   359,     8,     9,    10,    11,    12,    -1,
      99,   100,    -1,    -1,   359,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    -1,
      -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,   136,   359,    -1,
      -1,    -1,   141,    -1,    -1,    -1,    -1,   146,   147,   148,
      -1,    -1,    -1,    -1,   153,   154,   155,     3,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   207,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   365,   366,    44,    66,    67,    99,   100,   120,
     131,   134,   136,   141,   146,   147,   148,   153,   154,   155,
     388,   389,   390,   391,   392,   393,   442,   443,   444,   445,
     447,   448,   449,   452,   455,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   548,   582,   583,   584,
     585,   586,   587,   588,   589,   608,   610,     0,     3,    33,
      41,    44,    55,    77,    80,    82,    83,    90,   118,   122,
     134,   153,   156,   354,   367,   378,   384,   387,   396,   398,
     401,   403,   407,   408,   410,   411,   418,   427,   428,   483,
     485,   495,   534,   537,   549,   550,   551,   552,   591,   592,
     593,   594,   602,   603,   609,   611,   612,   613,    19,    20,
      43,   481,    20,    54,    62,    63,    64,   394,     3,   481,
     481,   118,   132,   133,   481,   481,     3,   109,   110,   118,
     137,   142,   144,   145,   208,   274,   349,   118,   118,    74,
     109,   110,   149,   150,   151,   152,    13,    15,    16,    17,
      18,    19,    20,    26,    27,    29,    31,    84,    90,   146,
     147,   181,   182,   198,   201,   205,   355,   362,   500,   513,
     518,   521,   522,   523,   525,   527,    35,    43,   358,   470,
     481,    19,    20,    42,    53,   380,   109,   115,    41,    60,
      82,   144,   385,   386,    19,    81,    19,    77,   123,    20,
     109,   527,    19,    19,   412,   412,   358,    68,    73,    86,
     123,   208,   274,   329,   334,   349,   412,    44,    77,    80,
      84,    85,    87,    88,    89,    94,   129,   134,   359,   413,
     430,   412,   412,    49,    86,   100,   103,   105,   144,   155,
     191,   208,   215,   216,   218,   220,   221,   223,   224,   226,
     229,   230,   232,   246,   247,   251,   253,   254,   256,   261,
     265,   266,   268,   269,   271,   272,   273,   359,   413,   412,
     275,   280,   281,   282,   317,   359,   413,   553,   554,   555,
     412,   330,   331,   359,   413,   412,    65,    87,   103,   127,
     128,   300,   335,   336,   337,   344,   359,   413,   437,   439,
     440,   412,    64,   144,   265,   359,   413,   604,   607,    68,
      69,    70,    72,    73,   359,   397,   400,   413,    70,   111,
     359,   399,   413,    35,    43,   358,   431,   394,     3,     3,
     394,    65,   395,     3,     3,    77,   457,   481,   481,     3,
      35,    43,   358,   434,    19,    20,    43,   482,     3,   143,
     453,     3,     3,   450,   456,   219,    19,    87,   151,   316,
     327,   328,   446,   446,    18,    19,   371,   373,   373,     3,
       3,     3,     3,     3,     3,     3,    15,    19,    28,   355,
     361,   517,   519,   525,    29,   355,   206,    27,   206,    15,
     361,   520,   527,   355,   355,   355,   355,   355,   355,   183,
     184,   185,   186,   507,   527,    15,    16,    17,    19,   355,
     368,   500,   501,   505,   508,   509,   511,   513,   514,   515,
       5,    75,    76,    78,    79,   104,   138,   187,   188,   190,
     191,   192,   193,   194,   195,   196,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   263,   264,   276,   277,   278,
     279,   347,   348,   526,   614,     3,     8,     9,    10,    11,
      12,    22,    23,    24,    25,    26,    27,    28,    29,    32,
      44,    45,    46,    47,    48,    49,    50,    51,    52,   382,
     383,    15,   471,     3,    22,    61,   379,    43,   358,   381,
     431,   355,   368,    20,    56,    57,   354,   130,   406,    15,
      17,    18,   104,   402,   484,    19,   404,   354,   434,   496,
     104,   358,   358,   409,   358,   431,    19,   417,    81,   368,
      34,    35,    36,    37,   368,   370,   429,    43,    90,    91,
      95,   101,   207,   414,   492,    95,   414,    95,    20,   434,
     354,   354,   358,   358,   234,   235,   354,   236,    20,   370,
      95,   144,   250,   126,   370,   354,   368,   371,   121,   371,
      71,   222,    71,   220,   227,   238,   239,   231,   233,   248,
     249,   248,   252,   370,   255,   257,   262,    77,   231,    86,
     267,   231,   270,   268,   370,   218,   354,   358,   402,   370,
      80,   368,   370,   354,   358,   358,    77,   332,   333,   354,
     358,    71,   600,   601,    20,   368,   358,    91,   342,   343,
     595,   368,   368,    71,   216,   345,   346,   354,   354,   358,
     358,   308,   373,    77,   354,   162,   225,   258,   267,   350,
     351,   352,   353,   354,    77,   370,    71,   370,    74,   354,
     354,   354,    71,    20,   377,   354,   354,    74,    92,    93,
     107,   108,   110,   432,   433,     3,   395,     3,   368,     3,
      19,     3,     3,     3,    92,   135,   435,   436,     3,   482,
       3,     3,     3,    77,   114,   121,   132,   454,     3,    43,
      77,    82,    89,    90,   102,   111,   112,   113,   114,   116,
     373,   451,   492,     3,    19,    77,    82,    83,    90,   118,
     156,   446,   446,   446,   590,    43,   446,    43,   446,     3,
       3,    29,   357,   375,   119,   119,   519,   519,   527,   519,
     519,    14,    15,   527,   531,   532,    26,   206,    27,   520,
     520,    29,   527,   527,   527,   527,   527,    19,    15,   360,
     356,   360,    28,   503,   504,   507,   527,     7,   360,   363,
      26,    27,   358,   360,   363,   527,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   166,   189,
     197,   202,   203,   359,   360,     3,   527,    20,   382,   354,
     527,   368,    58,    59,    58,    59,   424,   425,   354,   164,
     165,   166,   167,   168,   169,   170,   172,   173,   174,   175,
     176,   486,   487,   488,   490,   494,   124,   125,   126,   127,
     354,   405,   354,   355,   493,    19,   118,   359,   402,   419,
     422,   423,    19,   490,   491,    35,   368,   416,   102,   527,
     416,   416,   536,    71,    71,    49,   354,   354,   368,   260,
     370,   371,   354,   354,    30,   372,   368,   121,   368,    71,
     368,    71,   101,   228,   368,   368,   370,    71,   354,    81,
     354,   370,   354,   370,   228,   258,   259,   370,   417,   370,
     354,   354,   370,   370,   370,   354,   121,   370,    95,   556,
      19,   354,   354,   368,   423,   354,   354,   438,   439,   354,
     354,   354,   368,   354,   354,   354,    81,   117,   161,   441,
     370,   417,    20,   371,   371,   225,   605,   606,   368,   368,
     370,   368,   371,   373,   374,   359,   360,     3,   359,   360,
       3,    19,    15,   373,    19,    19,   491,   374,    19,     3,
      20,   581,   581,     3,    19,    80,   228,   275,   290,   308,
     322,   323,   446,   581,   446,   581,   368,   371,    15,    15,
     356,   360,   356,    27,   360,   360,   360,   356,   360,   356,
     360,   527,   527,     7,   360,   360,   356,    18,   501,   509,
      15,    18,   514,   355,   383,   354,   359,    20,   423,   354,
      19,   171,   354,   358,   371,   368,   356,   487,   489,   494,
     373,    27,   421,   360,    96,   415,   370,    87,   215,   216,
     359,   413,   535,   368,   368,   370,   354,   370,   354,   354,
      19,   121,   354,   368,   354,   368,   354,   368,   354,   354,
     354,   354,   354,   368,   402,   354,   354,   354,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   368,   368,    87,
     143,   229,   281,   305,   307,   313,   315,   319,   320,   359,
     557,   564,   567,   354,   354,   358,   599,   359,   354,   354,
     368,   104,   106,   104,   106,   359,   354,   354,   372,   371,
     318,   605,   433,   436,     3,     3,   402,   402,    15,   402,
     581,     3,   581,     3,   121,   121,   531,    27,   527,   527,
     527,   527,   527,   360,   356,   503,   527,   504,   506,   527,
     360,   527,   488,    19,    49,    84,   157,   158,   159,   160,
     161,   162,   163,   177,   180,   497,   498,   523,   524,   528,
     533,   354,   356,   119,    20,   374,   420,   422,    97,    98,
      99,   100,   538,   542,   538,   543,   371,   547,   354,   354,
     360,   354,   354,   368,   354,   354,   354,   354,   354,   354,
     576,   580,   370,   283,   284,   319,   283,   370,   558,   308,
     373,   560,   561,   559,   321,   370,   354,   324,   577,   598,
     438,   354,    20,   376,   376,   376,   376,   372,   368,     3,
       3,    15,    15,   356,   356,   356,   356,   360,   527,   356,
     360,    15,   356,    22,   355,    22,   355,   527,   527,   527,
     359,   533,   526,   614,   354,   527,   529,   530,   489,    15,
     374,   423,   358,   541,    30,   217,   544,   368,   354,   423,
     368,   368,   370,   368,   358,   402,   358,   358,   368,   368,
     358,   212,   231,   269,   331,   359,   597,   441,   354,   354,
     354,   354,   457,   457,   527,   356,     7,    28,   506,   359,
     527,   532,   527,   523,   354,   178,   358,    22,    22,    32,
     360,   354,   121,   541,   540,    19,    20,   218,   545,   354,
     577,   569,   562,   569,   565,   139,   140,   288,   426,   368,
     270,   291,   338,   339,   340,   341,   596,   354,   441,   441,
     441,   441,     3,     3,   356,   355,   356,     7,   356,   354,
     356,   354,   614,   358,   499,   533,   516,   527,   527,    90,
     146,   147,   201,   206,   530,    15,   105,   209,   210,   213,
     214,   359,   539,   371,   215,   546,   358,   579,   359,   373,
     570,   571,   143,   283,   306,   359,   563,   359,   235,   285,
     286,   287,   289,   300,   359,   437,   566,   368,   368,   368,
     212,   370,   503,   506,   356,   497,   179,     6,    15,    16,
      17,   355,   359,   500,   502,   505,   508,   510,   512,   354,
     354,   355,   355,   355,   355,   354,   354,   370,   211,   212,
     212,   368,   369,   368,   354,   370,   578,   306,   314,   572,
     370,   368,   370,   354,   368,   368,   368,   233,   113,   368,
      91,   299,   302,   354,   309,   360,   356,   354,   359,   499,
     497,   527,     7,   357,   360,   527,   527,   527,   527,   213,
     213,   213,    38,    39,    40,    64,   151,   208,   211,   212,
     235,   269,   281,   283,   285,   286,   287,   288,   289,   290,
     296,   300,   301,   304,   317,   325,   359,   437,   568,   368,
     354,   368,   368,   503,   356,   355,   502,   497,   510,   356,
     356,   356,   356,   369,   369,   369,   308,   358,   370,   310,
     288,   426,   368,   270,   370,   368,   368,   368,   233,   368,
     113,   368,   291,   292,   293,   294,   295,   296,   297,   298,
     326,    91,   299,   302,   293,   368,   318,   291,   354,   356,
     527,   354,   354,   354,   354,   370,   573,   311,   312,   368,
     368,   212,   370,   368,   368,   370,   370,   368,   370,    18,
     359,   575,   309,   303,   574,   354
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   364,   365,   365,   366,   366,   367,   368,   368,   368,
     369,   369,   369,   370,   370,   370,   370,   370,   370,   371,
     371,   372,   372,   373,   374,   374,   375,   375,   376,   377,
     377,   378,   379,   379,   380,   380,   380,   381,   381,   382,
     382,   383,   383,   383,   383,   383,   383,   383,   383,   383,
     384,   384,   385,   385,   385,   385,   386,   386,   386,   386,
     386,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     394,   395,   395,   395,   396,   397,   397,   397,   397,   398,
     399,   399,   400,   401,   401,   402,   402,   402,   403,   404,
     404,   405,   405,   405,   405,   406,   406,   407,   408,   409,
     409,   410,   410,   411,   411,   412,   412,   412,   413,   413,
     413,   413,   413,   413,   413,   413,   413,   413,   413,   413,
     413,   413,   414,   414,   414,   414,   415,   415,   415,   415,
     415,   416,   416,   417,   418,   418,   419,   420,   420,   420,
     421,   421,   422,   423,   423,   424,   425,   426,   426,   427,
     428,   428,   428,   429,   430,   431,   431,   431,   432,   432,
     433,   433,   433,   433,   433,   433,   434,   434,   434,   435,
     435,   436,   436,   437,   437,   438,   438,   439,   439,   440,
     441,   441,   441,   441,   441,   441,   442,   443,   444,   445,
     446,   446,   447,   448,   449,   450,   450,   450,   450,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   451,   451,
     452,   453,   453,   453,   453,   454,   454,   454,   455,   456,
     456,   456,   456,   456,   456,   456,   456,   457,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   470,   470,   471,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   481,   481,   482,   482,
     482,   484,   483,   485,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   487,   488,   488,
     489,   489,   490,   491,   491,   492,   493,   493,   494,   496,
     495,   497,   497,   498,   498,   499,   499,   500,   501,   501,
     501,   501,   502,   502,   502,   502,   502,   503,   504,   504,
     504,   505,   505,   506,   507,   507,   507,   507,   508,   508,
     508,   509,   509,   509,   509,   510,   510,   510,   510,   511,
     511,   512,   512,   513,   514,   514,   514,   514,   515,   515,
     516,   516,   516,   517,   517,   518,   518,   519,   519,   519,
     519,   519,   520,   520,   520,   521,   521,   521,   521,   521,
     521,   521,   521,   521,   521,   521,   522,   522,   523,   524,
     525,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   527,   527,   527,   527,   527,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   528,   528,
     528,   528,   528,   528,   529,   530,   530,   530,   531,   531,
     532,   532,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   534,   535,
     535,   535,   535,   536,   536,   537,   538,   539,   539,   539,
     539,   539,   539,   540,   540,   541,   541,   542,   543,   544,
     544,   544,   545,   545,   546,   546,   547,   548,   549,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   550,   550,   550,   550,   551,   552,   552,
     553,   553,   553,   553,   553,   553,   553,   554,   555,   556,
     556,   557,   557,   557,   557,   557,   557,   557,   557,   557,
     558,   557,   559,   557,   557,   557,   557,   560,   560,   561,
     562,   562,   563,   563,   563,   564,   564,   565,   565,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     567,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   569,   569,   570,
     571,   572,   572,   572,   573,   573,   574,   574,   575,   576,
     577,   577,   578,   578,   579,   579,   580,   581,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   590,   590,
     590,   590,   590,   590,   590,   590,   591,   592,   592,   592,
     592,   592,   593,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   595,   595,   595,   596,
     596,   596,   596,   596,   597,   597,   597,   597,   597,   597,
     597,   598,   598,   599,   599,   600,   601,   602,   603,   603,
     603,   603,   603,   604,   605,   605,   606,   606,   607,   607,
     607,   607,   607,   607,   607,   607,   607,   608,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   611,   611,
     611,   611,   611,   611,   611,   611,   611,   612,   612,   612,
     612,   613,   613,   613,   614,   614,   614,   614,   614,   614,
     614,   614,   614,   614,   614,   614,   614,   614,   614,   614,
     614,   614,   614,   614,   614,   614,   614
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       0,     4,     2,     0,     1,     2,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     3,     1,     1,     1,     1,     2,     4,     3,     3,
       3,     3,     3,     4,     5,     3,     3,     4,     2,     0,
       1,     0,     1,     2,     2,     2,     3,     2,     3,     2,
       3,     3,     3,     4,     5,     1,     1,     1,     4,     0,
       2,     2,     2,     1,     1,     0,     1,     3,     3,     0,
       8,     1,     4,     1,     1,     0,     1,     3,     0,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     4,     2,
       3,     2,     2,     1,     1,     1,     0,     2,     2,     2,
       2,     2,     1,     1,     3,     3,     0,     1,     1,     2,
       0,     1,     3,     1,     3,     0,     2,     2,     2,     2,
       3,     3,     3,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     3,     3,     4,     5,
       1,     0,     3,     4,     4,     0,     2,     3,     3,     3,
       2,     2,     2,     2,     3,     3,     2,     2,     1,     1,
       4,     0,     3,     3,     3,     0,     1,     1,     4,     0,
       2,     2,     2,     2,     2,     2,     2,     0,     2,     9,
       9,     4,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     1,     1,     3,     0,     1,     3,     3,     3,     3,
       4,     4,     4,     4,     2,     1,     1,     1,     1,     0,
       1,     0,     4,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     0,     3,
       1,     3,     1,     1,     1,     2,     3,     2,     4,     0,
       5,     0,     1,     1,     2,     1,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     5,    11,     1,     1,     1,     2,     1,     7,     9,
       7,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       3,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     2,     2,
       2,     0,     2,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     1,     5,     7,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     4,     1,     1,     1,
       1,     2,     2,     3,     3,     6,     3,     3,     3,     3,
       5,     6,     6,     6,     6,     4,     8,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     1,
       2,     2,     2,     0,     3,     5,     0,     2,     4,     4,
       4,     2,     2,     0,     3,     0,     3,     3,     2,     0,
       2,     2,     0,     2,     0,     2,     4,     5,     2,     3,
       3,     5,     6,     7,     6,     4,     4,     5,     6,     6,
       5,     3,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     6,     5,     5,     4,     2,     3,     3,
       1,     2,     3,     2,     4,     2,     1,     2,     4,     0,
       3,     2,     1,     2,     3,     3,     3,     3,     2,     3,
       0,     5,     0,     5,     2,     2,     1,     4,     1,     1,
       0,     3,     2,     2,     2,     5,     2,     0,     3,     0,
       2,     2,     3,     2,     2,     3,     2,     2,     2,     1,
       3,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     2,
       3,     2,     3,     3,     4,     2,     2,     2,     3,     3,
       3,     2,     3,     3,     4,     2,     1,     0,     2,     3,
       1,     0,     1,     2,     0,     2,     0,     1,     3,     0,
       0,     2,     0,     3,     0,     3,     4,     1,     0,     4,
       6,     6,     6,     7,     6,     7,     5,     0,     2,     3,
       2,     3,     3,     2,     3,     2,     2,     3,     3,     5,
       4,     4,     2,     3,     3,     4,     4,     4,     5,     5,
       4,     3,     4,     4,     4,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     2,     2,     2,     3,     3,
       4,     0,     3,     0,     3,     0,     3,     2,     3,     3,
       5,     5,     3,     2,     3,     3,     1,     2,     4,     3,
       3,     3,     2,     2,     2,     2,     2,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     1,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 683 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3527 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 684 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3533 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 697 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 3544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 707 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 3550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 708 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 3558 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 715 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 3564 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 716 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 3570 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 717 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 3576 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 725 "cf-parse.y" /* yacc.c:1646  */
    {(yyval.i) = !!(yyvsp[0].i); }
#line 3582 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 726 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3588 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 727 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3594 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 728 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3600 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 729 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 730 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3612 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 737 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 3621 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 744 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 3627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 745 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 3633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 749 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 3642 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 757 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 3648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 761 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 3657 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 765 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_mklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 3666 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 772 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 3676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 780 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 781 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3688 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 787 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 3699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 796 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 797 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 3711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 801 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 3721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 806 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 3727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 807 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 3733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 811 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 3739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 812 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 3745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 816 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 3751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 817 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 3757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 821 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 3763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 822 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 3769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 823 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 3775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 824 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 3781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 825 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 3787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 826 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 3793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 3799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 828 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 3805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 829 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 3811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 835 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 3817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 836 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 3827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 845 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 3833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 846 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 3839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 847 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 3845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 848 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 3851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 851 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 3857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 852 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 3863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 853 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 3869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 854 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 3875 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 855 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 3881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 856 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 3887 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 868 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 3893 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 871 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 3899 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 878 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 3905 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 881 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 3911 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 884 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 3917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 887 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 3923 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 890 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3929 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 895 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3935 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 896 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 3941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 897 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3947 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 905 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 3953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 910 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 3959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 911 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 3968 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 915 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
#line 3980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 922 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 3986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 928 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 3992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 933 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 937 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 951 "cf-parse.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].i) <= 0 || (yyvsp[0].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[0].i);
   }
#line 4023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 965 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 966 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 970 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 972 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 991 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 992 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 993 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 994 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1001 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1002 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1006 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1014 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1020 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1034 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1035 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1039 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1045 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1049 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1061 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4169 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1065 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1066 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1067 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1068 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1069 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1070 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4205 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1071 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4211 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1072 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4217 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1073 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4223 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1074 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1075 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1076 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1082 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1083 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1087 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1088 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1089 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1090 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1091 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1095 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1101 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1105 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1113 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4321 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1114 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4327 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1122 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1130 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1131 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1132 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1136 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4361 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1137 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1150 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1162 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1163 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1169 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1182 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 4408 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1196 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4414 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1197 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1198 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1203 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1207 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 4438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1208 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 4444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1209 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 4450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1210 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 4456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1211 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 4462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1212 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 4468 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4474 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1219 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1220 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4486 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1225 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 4498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1230 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 4504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1251 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 4524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1269 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 4530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1270 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 4536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1271 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 4542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1272 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 4548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1273 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 4554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1274 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 4560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1283 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 4566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1286 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 4572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1289 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 4578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1292 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 4584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1296 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 4590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1300 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 4596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1303 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 4602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1307 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 4608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1310 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 4618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1315 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 4629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1321 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 4641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1328 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 4651 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1333 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1338 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1343 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 4680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1347 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 4689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 4698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1355 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4713 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1365 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1373 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 4735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1377 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 4744 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1384 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4750 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1385 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 2; }
#line 4756 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1391 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 4762 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1394 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 4774 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1401 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 4786 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1408 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 4795 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1412 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 4805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1420 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 4811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1421 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 4817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1422 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 4823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1428 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 4829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1431 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 4837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1434 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 4843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1435 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 4849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1436 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 4855 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1437 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 4861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1438 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 4867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1439 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 4873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1440 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 4879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1445 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 4889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1450 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 4899 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1459 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 4908 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1466 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 4917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1473 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 4926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1481 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 4932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1483 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 4938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1485 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 4944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1487 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 4950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1489 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 4956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1491 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 4962 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1493 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 4968 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1496 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 4974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1499 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 4983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1505 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1506 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1507 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1511 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5007 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1512 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1519 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1521 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1523 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1525 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1527 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1529 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1533 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1537 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1540 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1543 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1544 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1545 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1549 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1550 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1551 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1559 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1560 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1569 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1573 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1574 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1575 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1576 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1577 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1578 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1579 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1580 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1581 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1582 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1583 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1584 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1585 "cf-parse.y" /* yacc.c:1646  */
    { 
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5224 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1606 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1617 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1618 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1625 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1626 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1633 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1642 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1650 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1674 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1675 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1679 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1692 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1695 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name); 
     cf_pop_scope();
   }
#line 5360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1708 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1709 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1712 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5378 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1713 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5384 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1717 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1720 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1729 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 5406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1743 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1744 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1745 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1749 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1750 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 5442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1751 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1752 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1753 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1757 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[0].x)); check_u16((yyval.i)); }
#line 5466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1760 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[0].i), (yyvsp[0].i)); }
#line 5472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1761 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[-2].i), (yyvsp[0].i)); }
#line 5478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1762 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0xFFFF; }
#line 5484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1766 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[-3].i32)), pair_b((yyvsp[-3].i32)), pair_a((yyvsp[-1].i32)), pair_b((yyvsp[-1].i32)));
   }
#line 5492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1769 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[-9].i32)) != pair_b((yyvsp[-9].i32))) || (pair_a((yyvsp[-7].i32)) != pair_b((yyvsp[-7].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[-9].i32)), (yyvsp[-3].i), pair_b((yyvsp[-7].i32)), (yyvsp[-1].i)); 
   }
#line 5503 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1778 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 5509 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1781 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 5515 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1782 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 5521 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1783 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 5527 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1784 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 5533 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1788 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5539 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1789 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1790 "cf-parse.y" /* yacc.c:1646  */
    {  (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 5551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1796 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1797 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1803 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1804 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1809 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1814 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1818 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 5596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1825 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1826 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 5608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 5614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1828 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 5623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1835 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1836 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1839 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 5641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1840 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 5653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1847 "cf-parse.y" /* yacc.c:1646  */
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 5665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1859 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 5671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1860 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 5677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1864 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1865 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1869 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5695 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5701 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1871 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
#line 5707 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1872 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 5713 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1873 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5719 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1877 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5725 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1878 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5731 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1879 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1883 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 5743 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1884 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 5749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1885 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 5755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 5761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1887 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1888 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1889 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 5779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1890 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 5785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1891 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 5791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1892 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 5797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1893 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 5803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1897 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 5809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 5815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1912 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 5840 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1935 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 5857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 5863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1950 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 5869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1951 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 5875 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1952 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 5881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1953 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 5887 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1954 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 5893 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1955 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 5899 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1956 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 5905 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1957 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 5911 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1958 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 5917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1962 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 5923 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1963 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5929 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1964 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5935 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1965 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1966 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5947 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1967 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1968 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1969 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1970 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1971 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1972 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 5983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1973 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 5989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1974 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 5995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1975 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1976 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6007 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1977 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1979 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1980 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1981 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1983 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1985 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6043 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1987 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1989 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1990 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1991 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1992 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1993 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2004 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2005 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2006 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2007 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2008 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2011 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2012 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2017 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6158 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2040 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6164 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6170 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2042 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6176 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6182 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2044 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6188 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6194 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2049 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6200 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2052 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6206 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6212 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2054 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6223 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2062 "cf-parse.y" /* yacc.c:1646  */
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2069 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2083 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2089 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6285 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2099 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2114 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2119 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2126 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2131 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 6353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2137 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2138 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2139 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 6376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2147 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 6382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2148 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2149 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2150 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2151 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2158 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 6420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2185 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
#line 6434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2196 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2197 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 6446 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2198 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6452 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2199 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 6458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2200 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 6464 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2201 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 6470 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2215 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
#line 6476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2218 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 6482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2222 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 6488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2223 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2224 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 6500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 6506 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 6512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2233 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2234 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2238 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 6544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2256 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 6550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2261 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[-1].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
#line 6574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2285 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2286 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2287 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[-4].a)) != !(yyvsp[-3].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[-4].a);
     BGP_CFG->iface = (yyvsp[-3].iface);
     BGP_CFG->remote_as = (yyvsp[-1].i);
   }
#line 6601 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2297 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 6607 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2298 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 6613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2299 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 6619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2300 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 6625 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2301 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 6631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2302 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 6637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2303 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 6643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2304 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 6649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2305 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 6655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2306 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 6661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2307 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 6667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2308 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 6673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2309 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 6679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2310 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 6685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2311 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 6691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2312 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 6697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2313 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 6703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2314 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 6709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2315 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 6715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2316 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 6721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2317 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 6727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2318 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 6733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2319 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 6739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2320 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 6745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2321 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 6751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2322 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->start_delay_time = (yyvsp[-1].i); }
#line 6757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2323 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 6763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2324 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 6769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2325 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 6775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2326 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 6781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2327 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 6787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2328 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 6793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2329 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 6799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2330 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 6805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2331 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
#line 6815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2336 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 6821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2337 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 6827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2338 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 6833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2339 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 6839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2340 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 6845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2341 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 6851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2342 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 6857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2343 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 6863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2354 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
#line 6875 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2370 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 6881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2371 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 6887 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2372 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? DEFAULT_ECMP_LIMIT : 0; }
#line 6893 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2373 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 6899 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2374 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 6905 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2378 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 6923 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2393 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 6929 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2402 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 6935 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2403 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 6941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2404 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 6947 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2405 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 6953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2406 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); check_defcost((yyvsp[0].i)); }
#line 6959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2407 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT_EBIT; check_defcost((yyvsp[0].i)); }
#line 6965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2408 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i);  check_defcost((yyvsp[0].i)); }
#line 6971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2409 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 6977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2410 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 6983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2411 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 6989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2412 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 6995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2424 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7006 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2438 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2439 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7018 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2440 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 7024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2444 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2445 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7036 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2454 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7042 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2455 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Retransmit int must be greater than zero"); }
#line 7048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2456 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2457 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; }
#line 7060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2458 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2459 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2460 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
#line 7078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2461 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
#line 7084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2462 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
#line 7090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2467 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
#line 7113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2488 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 7119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2489 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2490 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 7131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2491 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Retransmit int must be greater than zero"); }
#line 7137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2492 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; }
#line 7143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2493 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2494 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2495 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2496 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2497 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2498 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2499 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2500 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7191 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2501 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2502 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2503 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
#line 7209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2504 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
#line 7215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2505 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2506 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 7227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2507 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 7233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2508 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 7239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2509 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 7245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2510 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 7251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2512 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
#line 7257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2513 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
#line 7263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2514 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
#line 7269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2515 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
#line 7275 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2516 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
#line 7281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2517 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxbuf = (yyvsp[0].i) ; if (((yyvsp[0].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 7287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2518 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 7293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2519 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 7299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2520 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 7305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2521 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 7311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2522 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 7317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2534 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 7328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2544 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 7334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2545 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 7340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2554 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2555 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 7352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2559 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 7363 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2568 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 7389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2593 "cf-parse.y" /* yacc.c:1646  */
    { set_instance_id((yyvsp[0].i)); }
#line 7395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2607 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 7407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2618 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 7413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2621 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2624 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2629 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 7431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2632 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 7437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2637 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 7443 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2640 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 7449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2644 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 7455 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2647 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 7463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2650 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 7469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2651 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 7475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2652 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 7481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2653 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 7487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2654 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 7493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2655 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 7499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2656 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 7505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2657 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 7511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 7520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2672 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 7530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2677 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 7536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2678 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 7542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2684 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[-1].i));
     rip_init_config(RIP_CFG);
   }
#line 7551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2693 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[-1].i); }
#line 7557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2694 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->port = (yyvsp[-1].i); }
#line 7563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2695 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->period = (yyvsp[-1].i); }
#line 7569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2696 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->garbage_time = (yyvsp[-1].i); }
#line 7575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2697 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->timeout_time = (yyvsp[-1].i); }
#line 7581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2698 "cf-parse.y" /* yacc.c:1646  */
    {RIP_CFG->authtype = (yyvsp[-1].i); }
#line 7587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2700 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_ALWAYS; }
#line 7593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2701 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEIGHBOR; }
#line 7599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2702 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEVER; }
#line 7605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2707 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_PLAINTEXT; }
#line 7611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2708 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_MD5; }
#line 7617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2709 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_NONE; }
#line 7623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2714 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_BROADCAST; }
#line 7629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2715 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 7635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2716 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_QUIET; }
#line 7641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2717 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_NOLISTEN; }
#line 7647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2718 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
#line 7653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2722 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->metric = (yyvsp[0].i); }
#line 7659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2723 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->mode |= (yyvsp[0].i); }
#line 7665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2724 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_tos = (yyvsp[0].i); }
#line 7671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2725 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_priority = (yyvsp[0].i); }
#line 7677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2726 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = (yyvsp[0].i); }
#line 7683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2727 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = 2; }
#line 7689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2741 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
#line 7703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2760 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 7712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2769 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 7718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2770 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 7724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2774 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
  }
#line 7735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2783 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
#line 7748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2791 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 7757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2798 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 7763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2799 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 7769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2803 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 7779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2808 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 7790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2814 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 7798 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2817 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 7807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2822 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 7813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2823 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 7819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2824 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 7825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2825 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 7831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2826 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 7837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2830 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 7843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 2838 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 7849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 2838 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 7855 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 2838 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->passwords = get_passwords(); }
#line 7861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 2841 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 7867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 2841 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 7873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 2841 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 7879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 2841 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 7885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 2842 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 7891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 2842 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 2843 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 7903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 2844 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 7909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 2845 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 7915 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 2846 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 7921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 2847 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 7927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 2848 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 7933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 2849 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 7939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 2850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 7945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 2851 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 7951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 2852 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 7957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 7963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 7969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 7975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 7981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 7987 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 7993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 7999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 8003 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2855 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

